! Fourier transform and apply dip filter
program APPLY_FILTER

  use sep
  use fourier

  implicit none
  real, allocatable, dimension(:,:,:)  	:: data
  real, allocatable, dimension(:,:)    	:: filter
  complex, allocatable, dimension(:,:) 	:: cdata

  integer                              	:: n1, n2, n3, iw, ik, i3
  real                                 	:: o1, d1, o2, d2, o3, d3, sign1, sign2
  real                                 	:: ow, dw, ok, dk, w, k, wt


  call sep_init()



  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)
  
  write(0,*) 'n1, n2, n3', n1, n2, n3
 
 call from_param("sign1", sign1)
 call from_param("sign2", sign2)

  dw = 1./((n1-1)*d1)
  dk = 1./((n2-1)*d2)
  ow = -1./(2*d1)
  ok = -1./(2*d2)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

 if (exist_file('fk_before')) then
  call to_history("n1", n1, "fk_before")
  call to_history("o1", ow, "fk_before")
  call to_history("d1", dw, "fk_before")
  call to_history("n2", n2, "fk_before")
  call to_history("o2", ok, "fk_before")
  call to_history("d2", dk, "fk_before")
  call to_history("n3", n3, "fk_before")
  call to_history("o3", o3, "fk_before")
  call to_history("d3", d3, "fk_before")
  call to_history("esize", 8, "fk_before")
  call to_history("label1", 'Frequency  [1/s]', "fk_before")
  call to_history("label2", 'Wavenumber [1/m]', "fk_before")
 end if


 if (exist_file('fk_after')) then
  call to_history("n1", n1, "fk_after")
  call to_history("o1", ow, "fk_after")
  call to_history("d1", dw, "fk_after")
  call to_history("n2", n2, "fk_after")
  call to_history("o2", ok, "fk_after")
  call to_history("d2", dk, "fk_after")
  call to_history("n3", n3, "fk_after")
  call to_history("o3", o3, "fk_after")
  call to_history("d3", d3, "fk_after")
  call to_history("esize", 8, "fk_after")
  call to_history("label1", 'Frequency  [1/s]', "fk_after")
  call to_history("label2", 'Wavenumber [1/m]', "fk_after")
 end if

  allocate(data(n1,n2,n3))
  allocate(cdata(n1,n2))
  allocate(filter(n1,n2))

  data = 0.0
  cdata = 0.0
  filter= 0.0

  call sep_read(data)
  call sep_read(filter,"filter_in")

  call ft_init(n1, n2)

  do i3=1,n3  
    cdata(:,:) = data(:,:,i3)
    
!---- FFT Conversion ------------
  call ft1axis(.false., sign1, cdata)
  call ft2axis(.false., sign2, cdata)
 if (exist_file('fk_before')) then
    call sep_write(cdata, "fk_before")
 end if
!--------------------------------

  do iw = 1,n1
	do ik = 1,n2
		cdata(iw,ik) = cdata(iw,ik)*filter(iw,ik)
	end do
  end do

 if (exist_file('fk_after')) then
  call sep_write(cdata, "fk_after")
 end if

!##########################
  call ft1axis(.true., sign1, cdata)
  call ft2axis(.true., sign2, cdata)
!##########################
  data(:,:,i3) = real(cdata)

end do

 call sep_write(data)

end program APPLY_FILTER
