program CALC_AMP
  use sep
  implicit none

  integer             :: n1,n2,n3,esize,kk
  complex,allocatable :: data(:,:,:)
  real,allocatable    :: amp(:,:,:)
  real,parameter      :: pi = 3.14159265359

  call sep_init()
  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("esize",esize)
  if (esize.ne.8) call erexit("Error:  esize.ne.8")
  call to_history("esize",4)
  call sep_close()

  allocate(data(n1,n2,n3),amp(n1,n2,n3))

  ! Convert to Amplitude
  do kk=1,n3
    call sep_read(data(:,:,kk))
  end do
  amp = SQRT(aimag(data)**2 + real(data)**2)
  do kk=1,n3
    call sep_write(amp(:,:,kk))
  end do

  ! Exit this
  deallocate(data,amp)
  call exit(0)

end program
