program CALC_OBJ_VAL
    use sep
    use mem_mod
    implicit none

    integer                             :: nt, rec_nx, nshots
    real                                :: objfunc, rr
    real,allocatable,dimension(:,:,:)   :: residual
    real, dimension(:), allocatable     :: aa

    call sep_init()

    call from_aux("residual", "n1",nt)
    call from_aux("residual","n2",rec_nx)
    call from_aux("residual","n3",nshots)
    call mem_alloc3d(residual, nt,rec_nx,nshots)
    call mem_alloc1d(aa, nt*rec_nx*nshots)

    call sep_read(residual,"residual")

!----------  Calculate the objective function value ---------------
    aa=RESHAPE(residual, (/nt*rec_nx*nshots/))
    objfunc = DOT_PRODUCT(aa,aa)
    write(0,*) " objfunc =", objfunc

    call to_history("n1",1)
    call to_history("d1",1.0)
    call to_history("o1",0.0)
    call to_history("label1",'iteration')
    call srite( 'out', objfunc ,4*1)
!-------------------------------------------------------------------

    OPEN(UNIT=1,FILE="objfuncval.txt",FORM="FORMATTED",STATUS="REPLACE",ACTION="WRITE")
    WRITE(UNIT=1, FMT=*) objfunc
    CLOSE(UNIT=1)

end program