program DEAD_TRACE_RMV
    use sep
    use mem_mod
    implicit none

    integer                             :: nt, rec_nx, nshots, it, ix, is
    real                                :: summ
    real,allocatable,dimension(:,:,:)   :: residual


    call sep_init()
    call from_history("n1",nt)
    call from_history("n2",rec_nx)
    call from_history("n3",nshots)
    call mem_alloc3d(residual, nt,rec_nx,nshots)
    call sep_read(residual)

!   Zero out the dead traces
    do is=1,nshots
        do ix=1,rec_nx
            summ = 0.0
            do it=1,nt
                summ = summ + residual(it,ix,is)
            end do
            if (ISNAN(summ)) then
                residual(:,ix,is)=0.0
            end if
        end do
    end do

    call sep_write(residual)


    ! Exit this
    call sep_close()
    deallocate(residual)
    call exit(0)

end program
