! Fourier transform and apply dip filter
program DIP_FILTER_BUILDER


!============================================================

!  Makes a filter that operates on the fk-domain

!============================================================

  use sep

  implicit none
  real, allocatable, dimension(:,:)    	:: filter

  integer                              	:: n1, n2, n3, iw, ik, i3, zero_up
  real                                 	:: o1, d1, o2, d2, o3, d3, sign1, sign2, w_rise
  real                                 	:: ow, dw, ok, dk, w, k, wt, slope1

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)
  
  write(0,*) 'n1,n2, n3', n1, n2, n3
 
 call from_param("sign1", sign1)
 call from_param("sign2", sign2)
 call from_param("zero_up", zero_up)
 call from_param("slope1", slope1, 1800.0)
 call from_param("w_rise", w_rise, 1.0)


  dw = 1./((n1-1)*d1)
  dk = 1./((n2-1)*d2)
  ow = -1./(2*d1)
  ok = -1./(2*d2)

  call to_history("n1", n1)
  call to_history("o1", ow)
  call to_history("d1", dw)
  call to_history("n2", n2)
  call to_history("o2", ok)
  call to_history("d2", dk)
  call to_history("n3", 1)

  call to_history("label1", 'Frequency  [1/s]')
  call to_history("label2", 'Wavenumber [1/m]')

  allocate(filter(n1,n2))
  if (exist_file('filter_in')) then
  	call sep_read(filter,'filter_in')
  else
	filter = 1.0
  end if
    
  do iw = 1,n1
	w = (iw - 1) * dw + ow
	do ik = 1,n2
		k = (ik - 1) * dk + ok
		if(zero_up==1) then
			if (abs(w) >= w_rise) then
				if (((abs(w) - w_rise)/abs(k)) > slope1) then
					filter(iw,ik) = filter(iw,ik)*0.0
				else
					filter(iw,ik) = filter(iw,ik)*1.0
				end if
			else
				filter(iw,ik) = filter(iw,ik)*1.0
			end if
		else
			if (abs(w) >= w_rise) then
				if (((abs(w) - w_rise)/abs(k)) > slope1) then
					filter(iw,ik) = filter(iw,ik)*1.0
				else
					filter(iw,ik) = filter(iw,ik)*0.0
				end if
			else
				filter(iw,ik) = filter(iw,ik)*0.0
			end if
		end if
	end do
  end do

 call sep_write(filter)
 call sep_close()
 deallocate(filter)

end program DIP_FILTER_BUILDER
