







! Dot product test for nmo operator
program Dot_product_test
  use dptest_mod
  use sep
  use mem_mod
  ! use laplace_mod
  ! use bcder_mod
  ! use fbi_mod
  ! use lint_mod
  use initialize2
  ! use pad_mod
  ! use sscale_mod
  ! use comb_mod
  ! use step_mod
  ! use secder_mod
  ! use scats0_sso_mod
  use Hess_GN_mod_TJ2
  implicit none

  !===========================================================================
  ! Allocate and Initialize
  !---------------------------------------------------------------------------
  integer                               :: isou,rec_dx,rec_ox,sou_dx,sou_ox,nz,nx,nt, n_model, n_data, nt2
  integer                               :: bc1,bc2,bc3,bc4,wfld_j,sou_nx,rec_nx,rec_z,niter,nh,sou_z,sou_x
  integer                               :: bc
  real                                  :: dz,dx,dt,oz,ox,ot,tstep,vstep,dtw
  logical                               :: adjoint
  real, dimension(:,:,:), allocatable   :: data
  real, dimension(:,:,:,:), allocatable :: wflds0
  real, dimension(:,:), allocatable     :: vel_in, data_shot,veldt2,vwt,wt
  double precision, dimension(:,:,:,:), allocatable :: wflds0DBL
  double precision, dimension(:,:), allocatable     :: veldt2DBL,vwtDBL,wtDBL,vel_inDBL
  real, dimension(:), allocatable       :: source
  real, dimension(2)                    :: dot1, dot2

  !===========================================================================
  real, dimension(:,:,:,:), allocatable :: insrc
  real, dimension(:,:,:), allocatable   :: insrc_in
  !===========================================================================
  call sep_init()

  write(0,*) "======================================================"
  write(0,*) "--------- Inside the DOT PRODUCT TEST program"
 



! !===========  PAD DOT PRODUCT TEST  ========================= 
! !double is perfect. Add is wrong when dimensional parameters arent in order
! ! Single is off by one on the highest precision for ADD; acceptable
!   write(0,*) "---------- PAD TEST -----------"
!   nx=1000
!   nz=1000
!   nt=1000
!   sou_z=20
!   sou_x=20
!   rec_nx=5
!   rec_dx=2
!   sou_ox=20
!   rec_ox=20
!   rec_z=20
!   n_model = nt*rec_nx
!   n_data = nz*nx*nt
!   call pad_init(sou_z, sou_x, rec_nx, rec_dx, sou_ox, rec_ox, rec_z, nz, nx, nt)
!   call dptest(Rpad_op, n_model, n_data, dot1, dot2)


! !===========  LINT DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is off by more than precision. Not great, but atleast the DP result works
!   write(0,*) "---------- LINT TEST -----------"
!   nx=100
!   nz=100
!   nt=100
!   wfld_j=4
!   nt2 = (nt-1)*wfld_j + 1
!   n_model = nz*nx*nt
!   n_data = nz*nx*nt2
!   call lint_init(nz, nx, nt, wfld_j)
!   call dptest(lint_op, n_model, n_data, dot1, dot2)


! !===========  SSCALE DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is also perfect
!   write(0,*) "---------- SSCALE TEST -----------"
!   nx=100
!   nz=100
!   nt=100
!   n_model = nz*nx*nt
!   n_data = nz*nx*nt
!   allocate(veldt2(nz,nx))
!   allocate(wt(nz,nx))
!   call random_number(veldt2)
!   call random_number(wt)
!   call sscale_init(nz, nx, nt, dtw, veldt2, wt)
!   call dptest(sscale_op, n_model, n_data, dot1, dot2)




! !===========  BCDER DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is close but not that great
!   write(0,*) "---------- BCDER TEST -----------"
!   nx=200
!   nz=200
!   bc=80
!   bc1=bc
!   bc2=bc
!   bc3=bc
!   bc4=bc
!   n_model = nz*nx
!   n_data = nz*nx
!   call bcder_init(nz, nx, bc1, bc2, bc3, bc4)
!   call dptest(bcder_op, n_model, n_data, dot1, dot2)




! !===========  LAPLACE DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is off by one on the highest precision for ADD; acceptable
!   write(0,*) "---------- LAPLACE TEST -----------"
!   nx=200
!   nz=200
!   dz=10.0
!   dx=10.0
!   n_model = nz*nx
!   n_data = nz*nx
!   call laplace_init(nz, nx, dz, dx,1)
!   call dptest(laplace_op, n_model, n_data, dot1, dot2)





! !===========  COMB DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is off by one on the highest precision for ADD; acceptable
!   write(0,*) "---------- COMB TEST -----------"
!   nx=100
!   nz=100
!   nt=100
!   bc=10
!   bc1=bc
!   bc2=bc
!   bc3=bc
!   bc4=bc
!   dz=10
!   dx=10
!   n_model = nz*nx*nt
!   n_data = nz*nx*nt
!   ! allocate(veldt2DBL(nz,nx))
!   ! allocate(vwtDBL(nz,nx))
!   ! allocate(wtDBL(nz,nx))
!   ! call random_number(veldt2DBL)
!   ! call random_number(wtDBL)
!   ! call comb_init(nz, nx, bc1, bc2, bc3, bc4, dz, dx, veldt2DBL, vwtDBL, wtDBL)
!   allocate(veldt2(nz,nx))
!   allocate(vwt(nz,nx))
!   allocate(wt(nz,nx))
!   call random_number(veldt2)
!   call random_number(wt)
!   call comb_init(nz, nx, bc1, bc2, bc3, bc4, dz, dx, veldt2, vwt, wt)
!   call dptest(comb_op, n_model, n_data, dot1, dot2)





! !===========  STEP DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Close but not the best
!   write(0,*) "---------- STEP TEST -----------"
!   nx=100
!   nz=100
!   nt=100
!   bc=10
!   bc1=bc
!   bc2=bc
!   bc3=bc
!   bc4=bc
!   dz=10
!   dx=10
!   wfld_j=4
!   nt2 = (nt-1)*wfld_j + 1
!   n_model = nz*nx*nt2
!   n_data = nz*nx*nt2
!   ! allocate(veldt2DBL(nz,nx))
!   ! allocate(vwtDBL(nz,nx))
!   ! allocate(wtDBL(nz,nx))
!   ! call random_number(veldt2DBL)
!   ! call random_number(wtDBL)
!   allocate(veldt2(nz,nx))
!   allocate(vwt(nz,nx))
!   allocate(wt(nz,nx))
!   call random_number(veldt2)
!   call random_number(wt)
!   call step_init(nz, nx, nt2, bc1, bc2, bc3, bc4, dz, dx, veldt2, vwt, wt)
!   ! call step_init(nz, nx, nt2, bc1, bc2, bc3, bc4, dz, dx, veldt2DBL, vwtDBL, wtDBL)
!   call dptest(step_op, n_model, n_data, dot1, dot2)



! !===========  SECDER DOT PRODUCT TEST  ========================= 
! ! double is perfect
! ! Single is close but not the best
!   write(0,*) "---------- SECDER TEST -----------"
!   nx=200
!   nz=200
!   nt=200
!   dt=0.004
!   n_model = nz*nx*nt
!   n_data = nz*nx*nt
!   call secder_init(nz, nx, nt, dt)
!   call dptest(secder_op, n_model, n_data, dot1, dot2)



! !===========  SCATS DOT PRODUCT TEST  ========================= 
! ! double is perfect for both regular and reverse
! ! Single is ballpark close, but not great for either.
!   write(0,*) "---------- SCATS TEST -----------"
!   nx=200
!   nz=200
!   nt=200
!   nh=0
!   allocate(wflds0(nz,nx,nt,1))
!   call random_number(wflds0) 
!   n_model = nz*nx*(2*nh+1)
!   n_data = nz*nx*nt
!   call scats0_init(nz, nx, nt, nh, wflds0)
!   call dptest(scats0_op, n_model, n_data, dot1, dot2)




! !===========  WAVEMODELING DOT PRODUCT TEST  ========================= 
! ! Perfect result. "Add" results match the non-adding results
! ! Ballpark close result. "Add" results match the non-adding results
!   write(0,*) "---------- WAVE MODELING -----------"
!   call init_wavemodeling(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,sou_z)
!   ! call mem_alloc2d(vel_inDBL, nz, nx)
!   ! vel_inDBL = 2750.0
!   ! call model_update(vel_inDBL)
!   call mem_alloc2d(vel_in, nz, nx)
!   vel_in = 2750.0
!   call model_update(vel_in)
!   n_model = nt
!   n_data = nt*rec_nx
!   call dptest(L_source_func, n_model, n_data, dot1, dot2)





! !===========  BORN DOT PRODUCT TEST  =========================
! ! Perfect with double precision
! ! Close with double precision. ADD and NOT ADD DP results are different, as I would expect.
!   write(0,*) "---------- BORN MODELING -----------"
!   call init_rtm(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,bc1,bc2,bc3,bc4,wfld_j,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,tstep,vstep,niter)
!   ! call mem_alloc2d(vel_inDBL, nz, nx)
!   ! vel_inDBL = 2750.0
!   ! call model_update(vel_inDBL)
!   call mem_alloc2d(vel_in, nz, nx)
!   vel_in = 2750.0
!   call model_update(vel_in)
!   n_model = nz*nx
!   n_data = nt*rec_nx
!   call dptest(L_lop2_func, n_model, n_data, dot1, dot2)




!===========  BORN DOT PRODUCT TEST  (MODULAR) =========================
! Perfect with double precision
! Close with double precision. ADD and NOT ADD DP results are different, as I would expect.
  write(0,*) "---------- BORN MODELING (modular) -----------"
  call init_rtm(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z)
  call srcmaker(1)
  ! call mem_alloc2d(vel_inDBL, nz, nx)
  ! vel_inDBL = 2750.0
  ! call model_update(vel_inDBL)
  call mem_alloc2d(vel_in, nz, nx)
  vel_in = 2750.0
  call model_update(vel_in)
  n_model = nz*nx
  n_data = nt*rec_nx
  call dptest(L_lop3_func, n_model, n_data, dot1, dot2)






! !===========  GN HESS DOT PRODUCT TEST  ========================= 
! ! Perfect with double precision. The add and non-add results are the same tho ...
! ! Ball park close with double precision. The add and non-add results are the same tho ...

!   write(0,*) "---------- GN HESS MODELING -----------"
!   ! call init_rtm(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,bc1,bc2,bc3,bc4,wfld_j,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z,tstep,vstep,niter)
!   call init_rtm(nz,nx,nt,nh,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z)
!   ! call mem_alloc2d(vel_inDBL, nz, nx)
!   ! vel_inDBL = 2750.0
!   ! call model_update(vel_inDBL)
!   call mem_alloc2d(vel_in, nz, nx)
!   vel_in = 2750.0
!   call model_update(vel_in)
!   n_model = nz*nx*(2*nh+1)
!   n_data = nz*nx*(2*nh+1)
!   call dptest(GN_hess_func, n_model, n_data, dot1, dot2)
  



! !===========  PBS GN HESS DOT PRODUCT TEST  ========================= 
!   nz=400
!   nx=400
!   nh=0
!   call Hess_GN_init(nz,nx,ny, 0.0, 0.0, 0.0, 10.0, 10.0, 1.0, pbs_inputs_in)
!   n_model = nz*nx*(2*nh+1)
!   n_data = nz*nx*(2*nh+1)
!   call dptest(GN_hess_func, n_model, n_data, dot1, dot2)





!===========================================================
!=========================================================== 
  write(0,*) dot1
  write(0,*) "--------------------------------"
  write(0,*) dot2


!   call sep_close()




end program


