! Fourier transform and apply dip filter
program FFT2d

  use sep
  use fourier

  implicit none
  real, allocatable, dimension(:,:,:)  :: data
  complex, allocatable, dimension(:,:) :: cdata
  integer                              :: n1, n2, n3, i3
  real                                 :: o1, d1, o2, d2, o3, d3, sign1, sign2
  real                                 :: ow, dw, ok, dk, wt

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)
  
  write(0,*) 'n1 = ', n1, 'n2 = ',n2, 'n3 = ',n3

!-----------------------------------
 call from_param("sign1", sign1)
 call from_param("sign2", sign2)
!-----------------------------------

  dw = 1./((n1-1)*d1)
  dk = 1./((n2-1)*d2)
  ow = -1./(2*d1)
  ok = -1./(2*d2)

  call to_history("n1", n1)
  call to_history("o1", ow)
  call to_history("d1", dw)
  call to_history("n2", n2)
  call to_history("o2", ok)
  call to_history("d2", dk)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call to_history('label1', 'Frequency (w)')
  call to_history('label2', 'Wavenumber (k)')

  call to_history("esize", 8) ! (since the data are complex values)

  allocate(data(n1,n2,n3))
  allocate(cdata(n1,n2))
  data = 0.
  cdata = 0.

  call sep_read(data)
  call ft_init(n1, n2)

!-----------------------------------
  do i3=1,n3  
	cdata(:,:) = data(:,:,i3)
!----- Convert to F,K domain -------
	call ft1axis(.false., sign1, cdata)
	call ft2axis(.false., sign2, cdata)
	call sep_write(cdata)
  end do
!-----------------------------------
end program FFT2d
