program FORWARD_SYN_REC
	use sep
	use mem_mod
	use forward_modeling
	use initialize_forward
	implicit none

	!===========================================================================
	!	Allocate and Initialize
	!---------------------------------------------------------------------------
	integer                             	:: nt, nz, nx, isou
	integer                             	:: sou_nx, sou_ox, sou_dx, sou_z, sou_x
	integer                             	:: rec_nx, rec_ox, rec_dx, rec_z, rec_x
	real                                	:: dt, dz, oz, dx, ox, ot
	real, dimension(:,:), allocatable		:: rec_wave, vel
	real, dimension(:,:,:), allocatable		:: src_wavefield

	!===========================================================================
	
	call init_forward(nz,nx,nt,dz,dx,dt,oz,ox,ot,sou_nx,sou_dx,sou_ox,rec_nx,rec_dx,rec_ox,rec_z)
	
	call mem_alloc2d(vel, nz, nx)
	call sep_read(vel,"velmodel")
	call FORW_model_update(vel)

	call mem_alloc2d(rec_wave, nt, rec_nx)
	call mem_alloc3d(src_wavefield, nz, nx, nt)
	!---------------------------------------------------------------------------

	call from_param("isou", isou)
	call forward_wavefield(src_wavefield, rec_wave, isou) 
	call sep_write(rec_wave,"forward_data")
	if (exist_file('src_wavefield')) call sep_write(src_wavefield,"src_wavefield")


end program

