program H_FREE
	use sep
	use mem_mod
	use initialize1
	implicit none

	real                               	:: epsilon
	integer								:: nz, nx
	real, dimension(:,:), allocatable	:: G_pert, G, Hv

	call sep_init()
	call outfiles_Hfree()
	call from_param("epsilon", epsilon)
	call from_param("n1", nz)
	call from_param("n2", nx)

!---------------- Allocate -------------------------------
	call mem_alloc2d(G_pert, nz, nx)
	call mem_alloc2d(G, nz, nx)
	call mem_alloc2d(Hv, nz, nx)

!------------ Read in values ------------------------------
	call sep_read(G_pert, "G_pert")
	call sep_read(G, "G")

!------------ Calculate finite difference ------------------------------
	Hv = (G_pert - G)/epsilon

!-----------  Write outputs ------------------------------------------------
	call sep_write(Hv,'Hv')

	! call sep_close()
	write(0,*) "H_FREE program complete"

end program