program INITIALIZE
	use sep
	use mem_mod
	implicit none

	integer								:: nz, nx, niter
	real								:: dz, dx, oz, ox, rsold
	real, dimension(:), allocatable		:: A

	call sep_init()
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("d1", dz)
	call from_param("d2", dx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	niter = 10

!---------------- Allocate -------------------------------
	call mem_alloc1d(A, nz*nx)
	call sep_read(A,'grad_in')
	rsold = DOT_PRODUCT(A, A)

!-----------  Write outputs ------------------------------------------------




	if (exist_file('p')) then
		call to_history("n1",nz, 'p ')
		call to_history("n2",nx, 'p ')
		! call to_history("n3",300, 'p ')
		call to_history("d1",dz, 'p ')
		call to_history("d2",dx, 'p ')
		call to_history("o1",oz, 'p ')
		call to_history("o2",ox, 'p ')
		call to_history("label1",'z [km]', 'p ')
		call to_history("label2",'x [km]', 'p ')
		! call to_history("label3",'iteration', 'p ')
		call sep_write(A,'p')
	end if


	if (exist_file('r')) then
		call to_history("n1",nz, 'r ')
		call to_history("n2",nx, 'r ')
		! call to_history("n3",300, 'r ')
		call to_history("d1",dz, 'r ')
		call to_history("d2",dx, 'r ')
		call to_history("o1",oz, 'r ')
		call to_history("o2",ox, 'r ')
		call to_history("label1",'z [km]', 'r ')
		call to_history("label2",'x [km]', 'r ')
		! call to_history("label3",'iteration', 'r ')
		call sep_write(A,'r')
	end if





	if (exist_file('alpha_cg')) then
		call to_history("n1",1					, 'alpha_cg')
		call to_history("d1",1.0				, 'alpha_cg')
		call to_history("o1",0.0				, 'alpha_cg')
		call to_history("label1",'iteration'	, 'alpha_cg')
		call srite( 'alpha_cg', 0.0 ,4*1)
	end if




	if (exist_file('rsold_cg')) then
		call to_history("n1",1					, 'rsold_cg')
		call to_history("d1",1.0				, 'rsold_cg')
		call to_history("o1",0.0				, 'rsold_cg')
		call to_history("label1",'iteration'	, 'rsold_cg')
		call srite( 'rsold_cg', rsold ,4*1)
	end if




	if (exist_file('beta_cg')) then
		call to_history("n1",1					, 'beta_cg')
		call to_history("d1",1.0				, 'beta_cg')
		call to_history("o1",0.0				, 'beta_cg')
		call to_history("label1",'iteration'	, 'beta_cg')
		call srite( 'beta_cg', 0.0 ,4*1)
	end if



	if (exist_file('objfunc')) then
		call to_history("n1",1					, 'objfunc')
		call to_history("d1",1.0				, 'objfunc')
		call to_history("o1",0.0				, 'objfunc')
		call to_history("label1",'iteration'	, 'objfunc')
		call srite( 'objfunc', 0.0 ,4*1)
	end if



	if (exist_file('maxbeta')) then
		call to_history("n1",1					, 'maxbeta')
		call to_history("d1",1.0				, 'maxbeta')
		call to_history("o1",0.0				, 'maxbeta')
		call to_history("label1",'iteration'	, 'maxbeta')
		call srite( 'maxbeta', 0.0 ,4*1)
	end if


	OPEN(UNIT=1,FILE="alpha_old.txt",FORM="FORMATTED",STATUS="REPLACE",ACTION="WRITE")
	WRITE(UNIT=1, FMT=*) 1.0
	CLOSE(UNIT=1)


	OPEN(UNIT=1,FILE="rsold.txt",FORM="FORMATTED",STATUS="REPLACE",ACTION="WRITE")
	WRITE(UNIT=1, FMT=*) rsold
	CLOSE(UNIT=1)

end program