program MAXBETA
	use sep
	use mem_mod
	use calc_mod
	use initialize1
	implicit none

	real                               	:: Vsalt, oz, ox, dz, dx, maxalpha, maxbeta1, beta1, maxbeta2, beta2, alphacg
	integer								:: nz, nx, smooth_rad, count,numgamma
	logical								:: secondphi, test
	real, dimension(:,:), allocatable	:: phi2, vel_full, scaling, drlse_term1, drlse_term2
	real, dimension(:,:), allocatable	:: tomo_grad_ns, tomo_grad, phi_grad1, phi_grad2, s1, s2, new_phi


	call sep_init()
	call from_param("q1", Vsalt)
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)
	call from_param("secondphi", secondphi)
	call from_param("numgamma", numgamma)
	call from_param("smooth_rad", smooth_rad)


!---------------- Allocate ------------------------------
	write(0,*) " MAXBETA: Allocating"
	call mem_alloc2d(phi_grad1, nz, nx)
	call mem_alloc2d(new_phi, nz, nx)
	call mem_alloc2d(drlse_term1, nz, nx)
	call mem_alloc2d(tomo_grad_ns, nz, nx)
	call mem_alloc2d(tomo_grad, nz, nx)
	call mem_alloc2d(vel_full, nz, nx)
	! call mem_alloc2d(phi2, nz, nx)

!------------ Read in values ------------------------------
	write(0,*) " MAXBETA: Reading in arrays"
	call sep_read(drlse_term1, "drlse_term1")
	call sep_read(phi_grad1, "phi_grad1")
	call sep_read(tomo_grad_ns, "tomo_grad")
	call sep_read(vel_full, "vel_full")
! 	if (exist_file('phi2')) then
! 		call sep_read(phi2, "phi2")
! 	else
! 		phi2=1.0

	


! ! !(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
! 	write(0,*) " MAXBETA: Initializing serial2_calc_init"
! 	call serial2_calc_init( nz, nx, vel_full, phi2)


!------------ Normalize ------------------------------
	write(0,*) " MAXBETA: Normalizing Phigrad"
	phi_grad1 = phi_grad1/maxval(abs(phi_grad1))



! !(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
	write(0,*) "--------------------------   FIND MAXALPHA ----------------------------"
	maxalpha = 0.002*Vsalt
	write(0,*) "maxalpha = ", maxalpha



! !(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
	write(0,*) "--------------------------   FIND MAXBETA 1 ----------------------------"
	maxbeta1 = 100*1.0/maxval(abs(phi_grad1))
	beta1 = 100*maxbeta1
	count = 0
	do while (   ( abs(beta1 - maxbeta1) > 0.1 ) .or. (beta1 > maxbeta1)   )
		count = count + 1
		if (count > numgamma) then
			write(0,*) "max gamma MIGHT BE SMALLER! Stopped because hit iteration limit"
			exit
		end if
		beta1 = 0.999*maxbeta1
		new_phi = phi_grad1 + (drlse_term1/beta1)
		maxbeta1 = 1.0/maxval(abs(new_phi))
	end do
	if (count <= numgamma) then
		maxbeta1 = beta1
	end if
	write(0,*) "maxbeta = ", maxbeta1


! !(((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((
!-----------  Write outputs ------------------------------------------------
	call outfiles_maxbeta()

	call srite( 'maxbeta', maxbeta1 ,4*1)

	! if (exist_file('tomo_grad_out'))	call sep_write(tomo_grad,'tomo_grad_out')
	! if (exist_file('phi_grad1_out'))	call sep_write(phi_grad1,'phi_grad1_out')
	! if (exist_file('phi_grad2_out')) 	call sep_write(phi_grad2,'phi_grad2_out')

	call sep_close()

	OPEN(UNIT=1,FILE="maxalpha.txt",FORM="FORMATTED",STATUS="REPLACE",ACTION="WRITE")
	WRITE(UNIT=1, FMT=*) maxalpha
	CLOSE(UNIT=1)

	OPEN(UNIT=1,FILE="maxbeta1.txt",FORM="FORMATTED",STATUS="REPLACE",ACTION="WRITE")
	WRITE(UNIT=1, FMT=*) maxbeta1
	CLOSE(UNIT=1)

end program




