
program MODEL1_BUILDER
use sep
use calc_mod
implicit none

!===============================================================
real, dimension(:,:), allocatable	:: model, model2, smoothmodel, tphi1, tphi2, phi2, vel_back_true
integer								:: nz, nx, nz2, nx2, iz, ix, count, is, stencil, ip
real								:: q1, rad, dist, a, dz, dx, oz, ox, cz, cx, xx, zz, sum


! Allocate the internal arrays / dimensions
 call sep_init()
 call from_param("q1",q1,15.0)  ! Salt velocity
 call from_aux("phi1_in","n1",nz)
 call from_aux("phi1_in","n2",nx)
 call from_aux("phi1_in","d1",dz)
 call from_aux("phi1_in","d2",dx)
 call from_aux("phi1_in","o1",oz)
 call from_aux("phi1_in","o2",ox)

 call from_aux("vel_in","n1",nz2)
 call from_aux("vel_in","n2",nx2)

	if ( (nz.ne.nz2) .or. (nz.ne.nz2))  then
		write(0,*) " The background velocity and the input phi model dont have the same nz and nx!!"
		write(0,*) " Phi: nz = ", nz, " Vel: nz = ", nz2
		write(0,*) " Phi: nx = ", nx, " Vel: nx = ", nx2
	end if

	allocate(model(nz,nx), model2(nz,nx), smoothmodel(nz,nx), vel_back_true(nz,nx), tphi1(nz,nx), tphi2(nz,nx), phi2(nz,nx))

! Check for background velocity model input
	if (exist_file('vel_in')) then
		call sep_read(vel_back_true,'vel_in')
	else
		write(0,*) "You need to provide a background velocity input"
	end if


! Check for tphi1 input
	if (exist_file('phi1_in')) then
		call sep_read(tphi1,'phi1_in')
	else
		write(0,*) "You need to provide a true phi (tphi1) input"
	end if


! Finish true model creation
	model  = 0.0
	call calc_vel_init( nz, nx)
	call calc_velocity(tphi1, tphi1, vel_back_true, model, q1)


! Output the true model
	if (exist_file('truemodel')) then
		call sep_write(model,'truemodel')
 		call to_history("n1", nz,'truemodel')
 		call to_history("o1", oz,'truemodel')
 		call to_history("d1", dz,'truemodel')
 		call to_history("n2", nx,'truemodel')
 		call to_history("o2", ox,'truemodel')
 		call to_history("d2", dx,'truemodel')
 		call to_history("label1", 'z','truemodel')
 		call to_history("label2", 'x','truemodel')
	else
		write(0,*) "You need to provide a truemodel output called 'truemodel'"
	end if


end program
