program SERIAL_2bHess
	use sep
	use mem_mod
	use calc_mod
	use initialize1
	implicit none

	real                               	:: Vsalt, oz, ox, dz, dx, beta1, beta2, scaledown,wm_vel
	integer								:: nz, nx, smooth_rad, count
	logical								:: secondphi
	real, dimension(:,:), allocatable	:: phi2, vel_full, scaling, drlse_term1, drlse_term2
	real, dimension(:,:), allocatable	:: tomo_grad_ns, tomo_grad, phi_grad1, phi_grad2, s1, s2, new_phi


	call sep_init()
	call from_param("q1", Vsalt)
	call from_param("n1", nz)
	call from_param("n2", nx)
	call from_param("o1", oz)
	call from_param("o2", ox)
	call from_param("d1", dz)
	call from_param("d2", dx)
	call from_param("smooth_rad", smooth_rad)
	call from_param("secondphi", secondphi)
	call from_param("wm_vel", wm_vel)

	scaledown=1E15
	call outfiles_serial2()


!---------------- Allocate ------------------------------
	call mem_alloc2d(phi_grad1, nz, nx)
	call mem_alloc2d(new_phi, nz, nx)
	call mem_alloc2d(drlse_term1, nz, nx)

	call mem_alloc2d(phi2, nz, nx)
	call mem_alloc2d(vel_full, nz, nx)

	call mem_alloc2d(tomo_grad_ns, nz, nx)
	call mem_alloc2d(tomo_grad, nz, nx)
	call mem_alloc2d(scaling, nz, nx)
	call mem_alloc2d(s1, nz, nx)


!------------ Read in values ------------------------------
	call sep_read(phi2, "phi2")
	call sep_read(vel_full, "vel_full")
	call sep_read(scaling, "scaling")
	call sep_read(s1, "s1")
	call sep_read(drlse_term1, "drlse_term1")


!------------ Initialize ----------------------------------
	call serial2_calc_init( nz, nx, vel_full, phi2)


! !------------ Make phigrad ----------------------------------
! 	call sep_read(tomo_grad_ns, "RTMgrad")
! 	phi_grad1 = tomo_grad_ns*scaling*s1


!------------ Make delta phi (considers the Hessian) ----------------------------------
	call sep_read(tomo_grad_ns, "hessian_corrected_grad")
	phi_grad1 = (-1.0)*tomo_grad_ns*s1*scaling



!-----------  Mask salt area in tomo_grad  ------------------------------------------
	! call smoother(tomo_grad_ns,tomo_grad,smooth_rad)
	! tomo_grad_ns = tomo_grad
	! call smoother(tomo_grad_ns,tomo_grad,smooth_rad)
	! tomo_grad_ns = tomo_grad

	call salt_masker(tomo_grad_ns)
	call edge_smoother(tomo_grad_ns,tomo_grad,smooth_rad)  ! smooth_rad = 3 works well
	call water_masker(tomo_grad,wm_vel)



 !-----------  Normalize gradients --------------------------------------------------
	tomo_grad = tomo_grad/maxval(abs(tomo_grad))
	phi_grad1 = phi_grad1/maxval(abs(phi_grad1))


!------------ If second phi also ------------------------------
	if (secondphi) then
		call mem_alloc2d(phi_grad2, nz, nx)
		call mem_alloc2d(s2, nz, nx)
		call sep_read(s2, "s2")
		phi_grad2 = tomo_grad_ns*scaling*s2
		phi_grad2 = phi_grad2/scaledown
	end if


!-----------  Write outputs ------------------------------------------------

	if (exist_file('tomo_grad'))	call sep_write(tomo_grad,'tomo_grad')
	if (exist_file('phi_grad1'))	call sep_write(phi_grad1,'phi_grad1')
	if (exist_file('phi_grad2')) 	call sep_write(phi_grad2,'phi_grad2')

	call sep_close()

end program




