program SRC_CONVOLVE
    use sep
    use mem_mod
    implicit none

    integer                             :: nt, ntw, rec_nx, nshots, it, is, ir, lag
    real                                :: objfunc, rr, summ
    real,allocatable,dimension(:,:,:)   :: residual,convolved
    real, dimension(:), allocatable     :: wavelet, wavelet_in, trace

    call sep_init()

    call from_aux("wavelet","n1",ntw)
    call from_history("n1",nt)
    call from_history("n2",rec_nx)
    call from_history("n3",nshots)
    call mem_alloc3d(residual, nt,rec_nx,nshots)
    call mem_alloc3d(convolved, nt,rec_nx,nshots)
    call mem_alloc1d(trace, nt)
    call mem_alloc1d(wavelet, 2*nt)
    call mem_alloc1d(wavelet_in, ntw)

    call sep_read(residual)
    call sep_read(wavelet_in,"wavelet")
    wavelet=0.0
    wavelet(nt:(2*nt-1))=wavelet_in(1:nt)


    ! ----------  CONVOLUTION ----------------------------
    do is=1,nshots
        do ir=1,rec_nx
            trace=residual(:,ir,is) ! Grab a trace
            do lag=1,nt ! Lag shift
                summ=0.0
                do it=1,nt ! Summation over all multiplications for that lag shift
                    ! summ = summ + wavelet(nt+it-lag)*trace(nt-it+1)
                    summ = summ + wavelet(nt+it-lag)*trace(nt-it+1)
                end do
                convolved(nt-lag+1,ir,is)=summ
            end do

        end do
    end do

    call sep_write(convolved)


end program