program WAVEFIELD_COMP
	
	use sep
	use mem_mod
	implicit none

	!===========================================================================
	!	Allocate and Initialize
	!---------------------------------------------------------------------------
	integer                             	:: nt, nz, nx, np, ip, iz, ix
	real, dimension(:,:), allocatable		:: mask, tmpcoor, coor, tmpwave, wavefield_out
	real, dimension(:,:,:), allocatable		:: wavefield_in
	!===========================================================================

	call sep_init()
    call from_aux("wavefield_in","n1",nz)
    call from_aux("wavefield_in","n2",nx)
    call from_aux("wavefield_in","n3",nt)
	call mem_alloc2d(mask, nz, nx)
	call mem_alloc2d(tmpcoor, 2, nz*nx)
	call mem_alloc2d(tmpwave, nz*nx, nt)
	call mem_alloc3d(wavefield_in, nz, nx, nt)

	call sep_read(wavefield_in,"wavefield_in")
	call sep_read(mask,"mask")

	tmpwave=0.0
	tmpcoor=0.0
	ip=0

    write(0,*) "sum(wavefield_in) = ", sum(wavefield_in)

	do iz=1, nz
		do ix=1,nx
			if (mask(iz,ix)>0.0) then
				ip=ip+1
				tmpwave(ip,:) = wavefield_in(iz,ix,:)
				tmpcoor(1,ip) = iz
				tmpcoor(2,ip) = ix
			end if
		end do
	end do
    write(0,*) "sum(tmpwave) = ", sum(tmpwave)

	! Get the number of model points
	np=ip
	write(0,*) " np = ", np
	write(0,*) " Percent model points used: ", np*100/(nz*nx)

	! Make the output files
    call to_history("n1",np,'comp_wave')
    call to_history("n2",nt,'comp_wave')
    call to_history("label1",'Model_points','comp_wave')
    call to_history("label2",'Time','comp_wave')

    call to_history("n1",2,'coor')
    call to_history("n2",np,'coor')
    call to_history("label1",'(Z,X)','coor')
    call to_history("label2",'Time','coor')

	! Shrink to the size of the outputs
	call mem_alloc2d(wavefield_out, np, nt)
	call mem_alloc2d(coor, 2, np)
	coor=tmpcoor(:,1:np)
	wavefield_out=tmpwave(1:np,:)

    write(0,*) "sum(wavefield_out) = ", sum(wavefield_out)
    write(0,*) "sum(coor) = ", sum(coor)


	call sep_write(wavefield_out,"comp_wave")
	call sep_write(coor,"coor")

end program



