! dot product test module
module dptest_mod

  implicit none

  contains

  subroutine dptest(oper, n_model, n_data, dot1, dot2)
    integer,            intent(in)    :: n_model, n_data
    real, dimension(2), intent(out)   :: dot1, dot2
    interface
      function oper(adj, add, model, data) result(stat)
        logical, intent(in)           :: adj, add
        ! For when you are doing DP dot product testing
        ! double precision, dimension(:):: model, data
        real, dimension(:)            :: model, data
        integer                       :: stat
      end function
    end interface 
    ! For when you are doing DP dot product testing
    ! double precision, dimension(n_model)          :: model1, model2
    ! double precision, dimension(n_data)           :: data1, data2
    real, dimension(n_model)          :: model1, model2
    real, dimension(n_data)           :: data1, data2
    integer                           :: stat
    integer                           :: time(8), seed(2)



    call DATE_AND_TIME(values=time)     ! Get the current time 
    seed(1) = time(4) * (360000*time(5) + 6000*time(6) + 100*time(7) + time(8)) 
    CALL RANDOM_SEED(PUT=seed)

    call random_number(model1)
    call random_number(data2)

! dot product test with add = false
write(0,*) " sum(model1) = ", sum(model1)
    stat = oper(.false., .false., model1, data1)
write(0,*) " sum(data1) = ", sum(data1)
    write(0,*) "=============== OP 1 done (forward) ================"
    ! write(0,*) "sum(data1) = ", sum(data1)
    dot1(1) = dot_product(data1, data2)
    stat = oper(.true., .false., model2, data2)
    write(0,*) "=============== OP 2 done (adjoint) ================"
    ! write(0,*) "sum(model2) = ", sum(model2)

    dot1(2) = dot_product(model1, model2)

! dot product test with add = true
    stat = oper(.false., .true., model1, data1)
    write(0,*) "=============== OP 3 done (forward) ================"
    dot2(1) = dot_product(data1, data2)
    stat = oper(.true., .true., model2, data2)
    write(0,*) "=============== OP 4 done (adjoint) ================"
    dot2(2) = dot_product(model1, model2)

  end subroutine

end module
