
! COMPRESSED OPERATORS
module scats0_sso_mod

	use sep
	implicit none
	integer, private							:: nz, nx, nt, nh, np
	real, dimension(:,:,:), pointer, private	:: wflds0
	real, dimension(:,:), pointer, private	    :: coor
	contains



	subroutine scats0_init(nz_in, nx_in, nt_in, nh_in, wflds0_in, coor_in, np_in)
		integer                              :: nz_in, nx_in, nt_in, nh_in, np_in
		real, dimension(:,:,:), target       :: wflds0_in
		real, dimension(:,:), target         :: coor_in
		nz = nz_in
		nx = nx_in
		nt = nt_in
		np = np_in
		nh = nh_in	! max half offset expressed in samples
		wflds0 => wflds0_in
		coor => coor_in
		! write(0,*)" SCATS :: sum(coor) = ", sum(coor)
		! write(0,*)" SCTAS :: sum(wflds0) = ", sum(wflds0)
	end subroutine




	function scats0_op(adj, add, model, data) result(stat)
		logical,intent(in) 				:: adj, add
		real,dimension(:)               :: model, data
		integer            				:: stat
		call scats0_op2(adj, add, model, data,1)
		! call scats0_op2_REV(adj, add, model, data,1)
		stat=0
	end function




	subroutine scats0_op2(adj,add,model,data,ith)
		logical                        	:: adj,add
		integer                        	:: it,iz,ix,ip,ith
		real,dimension(nz,nx,nt)        :: data
		real,dimension(nz,nx)    		:: model

		if ((adj .eqv. .true.) .and. (add .eqv. .false.)) model = 0.
		if ((adj .eqv. .false.) .and. (add .eqv. .false.)) data = 0.

		if (adj .eqv. .true.) then
			! write(0,*) " SCATS sum(data)  adj   =  ", sum(data)
			! write(0,*) " SCATS sum(wflds0)  adj =  ", sum(wflds0)
	       	do ip = 1,np
		       	iz = coor(1,ip)
		       	ix = coor(2,ip)
				do it=1,nt
                   	model(iz,ix) = model(iz,ix) - wflds0(ip,it,ith) * data(iz,ix,it)      	                   		
		    	end do   
		    end do
		else
			! write(0,*) " SCATS sum(data) for =  ", sum(data)
			! write(0,*) " SCATS sum(wflds0) for =  ", sum(wflds0)
	       	do ip = 1,np
		       	iz = coor(1,ip)
		       	ix = coor(2,ip)
				do it=1,nt
                   	data(iz,ix,it) = data(iz,ix,it) - wflds0(ip,it,ith) * model(iz,ix)                       
		        end do
		    end do    
		end if 
		        
	end subroutine








	subroutine scats0_op2_REV(adj,add,model,data,ith)
		logical                        	:: adj,add
		integer                        	:: it,iz,ix,ip,ith,it2
		real,dimension(nz,nx,nt)        :: data
		real,dimension(nz,nx)    		:: model

		if ((adj .eqv. .true.) .and. (add .eqv. .false.)) model = 0.
		if ((adj .eqv. .false.) .and. (add .eqv. .false.)) data = 0.

		if (adj .eqv. .true.) then
			! write(0,*) " SCATS sum(data)  adj   =  ", sum(data)
			! write(0,*) " SCATS sum(wflds0)  adj =  ", sum(wflds0)
	       	do ip = 1,np
		       	iz = coor(1,ip)
		       	ix = coor(2,ip)
				do it=1,nt
					it2=nt-(it-1)
                   	model(iz,ix) = model(iz,ix) - wflds0(ip,it2,ith) * data(iz,ix,it)      	                   		
		    	end do   
		    end do
		else
			! write(0,*) " SCATS sum(data) for =  ", sum(data)
			! write(0,*) " SCATS sum(wflds0) for =  ", sum(wflds0)
	       	do ip = 1,np
		       	iz = coor(1,ip)
		       	ix = coor(2,ip)
				do it=1,nt
					it2=nt-(it-1)
                   	data(iz,ix,it) = data(iz,ix,it) - wflds0(ip,it2,ith) * model(iz,ix)                       
		        end do
		    end do    
		end if 
		        
	end subroutine





end module









!==================================================================================
!               DOUBLE PRECISION
!==================================================================================



! module scats0_sso_mod

! 	use sep
! 	implicit none
! 	integer, private							            :: nz, nx, nt, nh, it, ix, iz, ih
! 	double precision, dimension(:,:,:,:), pointer, private	:: wflds0
! 	contains



! 	subroutine scats0_init(nz_in, nx_in, nt_in, nh_in, wflds0_in)
! 		integer                                          :: nz_in, nx_in, nt_in, nh_in
! 		double precision, dimension(:,:,:,:), target     :: wflds0_in
! 		nz = nz_in
! 		nx = nx_in
! 		nt = nt_in
! 		nh = nh_in	! max half offset expressed in samples
! 		wflds0 => wflds0_in
! 	end subroutine




! 	function scats0_op(adj, add, model, data) result(stat)
! 		logical,intent(in) 				:: adj, add
! 		double precision,dimension(:)   :: model, data
! 		integer            				:: stat
! 		call scats0_op2(adj, add, model, data,1)
! 		stat=0
! 	end function




! 	subroutine scats0_op2(adj,add,model,data,ith)
! 		logical                                  	:: adj,add
! 		integer                                  	:: it,iz,ix,ih,leftlag,rightlag,lag, ith
! 		double precision,dimension(nz,nx,nt)        :: data,temp1
! 		double precision,dimension(nz,nx,-nh:nh)    :: model

! 		if ((adj .eqv. .true.) .and. (add .eqv. .false.)) model = 0.
! 		if ((adj .eqv. .false.) .and. (add .eqv. .false.)) data = 0.

! 		if (adj .eqv. .true.) then
! 			! write(0,*) " SCATS sum(data)   =  ", sum(data)
! 			! write(0,*) " SCATS sum(wflds0) =  ", sum(wflds0)

! 			!$OMP PARALLEL DO private(it,ix,iz,ih,leftlag,rightlag,lag)
! 			do it=1,nt
! 		       	do ix = 1,nx
! 		          	leftlag  = ix-1
! 		           	rightlag = nx-ix
! 		           	lag = min(leftlag,rightlag,nh)
! 		       		do ih = -lag,lag
! 		        		do iz = 1,nz
! 		                   	model(iz,ix,ih) = model(iz,ix,ih) - wflds0(iz,ix-ih,it,ith) * data(iz,ix+ih,it)      	                   		
! 						end do
! 		        	end do
! 		    	end do   
! 		    end do
! 			!$OMP END PARALLEL DO 
! 		else
! 			! write(0,*) " SCATS sum(data)   =  ", sum(data)
! 			! write(0,*) " SCATS sum(wflds0) =  ", sum(wflds0)
! 			!$OMP PARALLEL DO private(it,ix,iz,ih,rightlag,leftlag,lag)  
! 			do it=1,nt
! 		       	do ix = 1,nx
! 		           	leftlag  = ix-1
! 		           	rightlag = nx-ix
! 		           	lag = min(leftlag,rightlag,nh)
! 		       		do ih = -lag,lag
! 		            	do iz = 1,nz
! 			                   	data(iz,ix+ih,it) = data(iz,ix+ih,it) - wflds0(iz,ix-ih,it,ith) * model(iz,ix,ih)                       
! 							end do
! 					end do
! 		        end do
! 		    end do    
! 			!$OMP END PARALLEL DO   
! 		end if 
		        
! 	end subroutine






! 	subroutine scats0_op2_REV(adj,add,model,data,ith)
! 		logical                              :: adj,add
! 		integer                              :: it,it2,iz,ix,ih,leftlag,rightlag,lag, ith
! 		double precision,dimension(nz,nx,nt)             :: data,temp1
! 		double precision,dimension(nz,nx,-nh:nh)         :: model

! 		if ((adj .eqv. .true.) .and. (add .eqv. .false.)) model = 0.
! 		if ((adj .eqv. .false.) .and. (add .eqv. .false.)) data = 0.

! 		if (adj .eqv. .true.) then
! ! if (exist_file('wflds0' )) call sep_write(wflds0, 'wflds0' )
! ! if (exist_file('datascat' )) call sep_write(data, 'datascat' )

! 			!$OMP PARALLEL DO private(it,ix,iz,ih,leftlag,rightlag,lag)
! 			do it=1,nt
! 				it2=nt-(it-1)
! 		       	do ix = 1,nx
! 		          	leftlag  = ix-1
! 		           	rightlag = nx-ix
! 		           	lag = min(leftlag,rightlag,nh)
! 		       		do ih = -lag,lag
! 		        		do iz = 1,nz
! 		                   	model(iz,ix,ih) = model(iz,ix,ih) - wflds0(iz,ix-ih,it2,ith) * data(iz,ix+ih,it)      	                   		
! 						end do
! 		        	end do
! 		    	end do   
! 		    end do
! 			!$OMP END PARALLEL DO 
! 		else
! 			!$OMP PARALLEL DO private(it,ix,iz,ih,rightlag,leftlag,lag)  
! 			do it=1,nt
! 				it2=nt-(it-1)
! 		       	do ix = 1,nx
! 		           	leftlag  = ix-1
! 		           	rightlag = nx-ix
! 		           	lag = min(leftlag,rightlag,nh)
! 		       		do ih = -lag,lag
! 		            	do iz = 1,nz
! 			                   	data(iz,ix+ih,it) = data(iz,ix+ih,it) - wflds0(iz,ix-ih,it2,ith) * model(iz,ix,ih)                       
! 							end do
! 					end do
! 		        end do
! 		    end do    
! 			!$OMP END PARALLEL DO   
! 		end if 
		        
! 	end subroutine


! end module










!		OLD ALI SUBROUTINE

	! subroutine scats0_op2(adj, add, model, data,ith)
	! 	logical,intent(in)				:: adj, add 
	! 	real, dimension(nz,nx,nh)		:: model, modela
	! 	real, dimension(nz,nx,nt)		:: data
	! 	integer							:: ith

	! 	if(adj) then
	! 		if(.not. add) model = 0.
	! 		do it=1,nt
	! 			do ih=1,nh
	! 				do ix=1,nx
	! 					! model = model + data(:,:,it)*wflds0(:,:,it,ith)
	! 					model(:,ix,ih) = model(:,ix,ih) +data(:,ix+ih-1,it) * wflds0(:,ix-ih+1,it,ith)
	! 				end do
	! 			end do
	! 		end do
	! 	else
	! 		if(.not. add) data = 0.
	! 		do it=1,nt
	! 			do ih=1,nh
	! 				do ix=1,nx
	! 					! data(:,:,it) = data(:,:,it) + model*wflds0(:,:,it,ith)
	! 					data(:,ix+ih-1,it) = data(:,ix+ih-1,it) + model(:,ix,ih)*wflds0(:,ix,it,ith)
	! 				end do
	! 			end do
	! 		end do
	! 	end if

	! end subroutine
