! Test vref_pseduo lloyd algorithm of bwi src package.
! Yang, 2014.04
! Usage: *.x <invel.H >outvel.H nvrf=? vrefout=vref.H

! Output is the approximated input vel cube values with the nearest vref values chosen by the program with assinged 'nvrf' parameter

program main
  use sep
  use base_ioutil_mod
  use bwi_velref_mod

  implicit none

  real, allocatable :: in(:,:,:),bvrf(:),bvout(:,:,:),bvrfout(:,:)
  integer           :: n1, n2, n3, nz, nvrf, stat, jvrf,ivrf,iz,ix,iy
  real              :: d1, d2, d3, o1, o2, o3, vdif1,vdif2
  type(axis)        :: ax1,ax2,ax3,ax_ref
  
  call initpar()
  
  call from_history("n1", n1); call from_history("d1", d1); call from_history("o1", o1)
  call from_history("n2", n2); call from_history("d2", d2); call from_history("o2", o2)
  call from_history("n3", n3); call from_history("d3", d3); call from_history("o3", o3)
  call from_param("nvrf",nvrf,4)

  call hinaxis("in",ax1,1)
  call hinaxis("in",ax2,2)
  call hinaxis("in",ax3,3)
  
  nz = n3
  write(0,*) "nz=",nz
  allocate(in(n1,n2,n3),bvout(n1,n2,n3))
  allocate(bvrf(nvrf),bvrfout(nz,nvrf))

  call sreed("in", in, 4*n1*n2*n3)
  stat = bwi_velref_init(nvrf)
  do iz=1, nz
    stat = bwi_velref_oper(in(:,:,iz), bvrf)
    bvrfout(iz,:) = bvrf
    do iy=1, n2
    do ix=1, n1
      jvrf = 1
      ! Trying to locate the nearest vref values, for linear interpolation, it is not enough
      do ivrf=1, nvrf-1
         vdif1 = abs(in(ix,iy,iz)-bvrf(ivrf)  )
         vdif2 = abs(in(ix,iy,iz)-bvrf(ivrf+1))
         if (vdif1<vdif2) then
            jvrf = ivrf
            exit
         else
            jvrf = ivrf+1
         end if
      end do
      bvout(ix,iy,iz) = bvrf(jvrf)
    end do
    end do
  end do
  
  !approximate the vel values using velref 
  call to_history("n1", n1); call to_history("d1", d1); call to_history("o1", o1)
  call to_history("n2", n2); call to_history("d2", d2); call to_history("o2", o2)
  call to_history("n3", n3); call to_history("d3", d3); call to_history("o3", o3)
  call srite("out", bvout, 4*n1*n2*n3)

  ax_ref % n = nvrf; ax_ref%o=1; ax_ref%d=1
  call houaxis("vrefout",ax3,1)
  call houaxis("vrefout",ax_ref,2)
  call srite("vrefout",bvrfout,4*nvrf*nz)
end program

