#include <stdio.h>
#include "string.h"
#include <math.h>

#include "mpi.h"
#include "seplib.h"
#include "bwi-files-mpi.c"
#include "bwi-commd-mpi.c"

#define LMAX_DIR 256
#define LMAX_FNS 256
#define LMAX_CMD 1024

int main(int argc, char* argv[]) {
   
   char bindir[LMAX_DIR], datdir[LMAX_DIR], resdir[LMAX_DIR], tmpdir[LMAX_DIR], datapath[LMAX_DIR];
   char fncsou[LMAX_FNS], fncrec[LMAX_FNS], fnbvel[LMAX_FNS], fnbimg[LMAX_FNS];
   char fngrdo[LMAX_FNS], fngrdp[LMAX_FNS], fnsrch[LMAX_FNS], fnfobj[LMAX_FNS]; 
   char fnimsk[LMAX_FNS], fngmsk[LMAX_FNS];
   char fnmmov[LMAX_FNS], fnfmov[LMAX_FNS];
   char fncsou_orig[LMAX_FNS], fncrec_orig[LMAX_FNS], fnbvel_orig[LMAX_FNS], fnbimg_orig[LMAX_FNS];
   char fngrdo_orig[LMAX_FNS], fngrdp_orig[LMAX_FNS], fnsrch_orig[LMAX_FNS], fnfobj_orig[LMAX_FNS];
   char fnimsk_orig[LMAX_FNS], fngmsk_orig[LMAX_FNS], fnmmov_orig[LMAX_FNS], fnfmov_orig[LMAX_FNS]; 
   char fncsou_temp[LMAX_FNS], fncrec_temp[LMAX_FNS], fnbvel_temp[LMAX_FNS], fnbimg_temp[LMAX_FNS];
   char fngrdo_temp[LMAX_FNS], fngrdp_temp[LMAX_FNS], fnsrch_temp[LMAX_FNS], fnfobj_temp[LMAX_FNS];
   char fnimsk_temp[LMAX_FNS], fngmsk_temp[LMAX_FNS], fnmmov_temp[LMAX_FNS], fnfmov_temp[LMAX_FNS];
   char cpy_csou[LMAX_CMD], cpy_crec[LMAX_CMD], cpy_bvel[LMAX_CMD], cpy_bimg[LMAX_CMD];
   char cpy_grdo[LMAX_CMD], cpy_grdp[LMAX_CMD], cpy_srch[LMAX_CMD], cpy_fobj[LMAX_CMD];
   char cpy_mmov[LMAX_CMD], cpy_fmov[LMAX_CMD], cpy_imsk[LMAX_CMD], cpy_gmsk[LMAX_CMD];
   char cmd_imagcube[LMAX_CMD], cmd_gradinto[LMAX_CMD], cmd_gradintp[LMAX_CMD], cmd_residual[LMAX_CMD];
   char cmd_grdoprcs[LMAX_CMD], cmd_grdpprcs[LMAX_CMD], cmd_sdsdstep[LMAX_CMD], cmd_sdcgstep[LMAX_CMD];
   char par_imagcube[LMAX_CMD], par_gradient[LMAX_CMD], par_residual[LMAX_CMD], par_gradprcs[LMAX_CMD];
   char cmd_initfile[LMAX_CMD], par_initfile[LMAX_CMD];
   char suffix[20], shot_string[24], numstr[4];
   
   axis ahx_igrid={1,1.,0.}, ahy_igrid={1,1.,0.}, ax_igrid={1,1.,0.}, ay_igrid={1,1.,0.}, az_igrid={1,1.,0.};
   axis ax_vgrid={1,1.,0.}, ay_vgrid={1,1.,0.}, az_vgrid={1,1.,0.};
   axis aiter={1,1.,0.};
   
   float *btmp=NULL, *bimg=NULL;
   float *grdo=NULL, *grdp=NULL, *srch=NULL;
   float *f=NULL;
   
   float fobj, sfac, alph, fopt, norm;
   
   int irank, nrank, nsmp_igrid, nsmp_vgrid, nsb, nsrc, niter, isrc, iter, ismp, iopt, check, masks, stat;
   
   
   MPI_Init(&argc,&argv);
   MPI_Comm_rank(MPI_COMM_WORLD, &irank);
   MPI_Comm_size(MPI_COMM_WORLD, &nrank);
   
   initpar(argc,argv);
   doc(" ");
   
   if (0==getch("bindir","s",&bindir)) strcpy(bindir,"./");
   if (0==getch("datdir","s",&datdir)) strcpy(datdir,"./");
   if (0==getch("resdir","s",&resdir)) strcpy(resdir,"./");
   if (0==getch("tmpdir","s",&tmpdir)) strcpy(tmpdir,"./");
   
   if (0==getch("suffix","s",&suffix)) strcpy(suffix,"./");
   
   if (0==getch("fncsou","s",&fncsou)) strcpy(fncsou,"CSOU.H");
   if (0==getch("fncrec","s",&fncrec)) strcpy(fncrec,"CREC.H");
   if (0==getch("fnbvel","s",&fnbvel)) strcpy(fnbvel,"BVEL.H");
   if (0==getch("fnbimg","s",&fnbimg)) strcpy(fnbimg,"BIMG.H");
   
   if (0==getch("fnfobj","s",&fnfobj)) strcpy(fnfobj,"FOBJ.H");
   if (0==getch("fngrdo","s",&fngrdo)) strcpy(fngrdo,"GRDO.H");
   if (0==getch("fngrdp","s",&fngrdp)) strcpy(fngrdp,"GRDP.H");
   if (0==getch("fnsrch","s",&fnsrch)) strcpy(fnsrch,"SRCH.H");
   
   if (0==getch("fnimsk","s",&fnimsk)) strcpy(fnimsk,"IMSK.H");
   if (0==getch("fngmsk","s",&fngmsk)) strcpy(fngmsk,"GMSK.H");
   
   if (0==getch("fnmmov","s",&fnmmov)) strcpy(fnmmov,"MMOV.H");
   if (0==getch("fnfmov","s",&fnfmov)) strcpy(fnfmov,"FMOV.H");
   
   if (0==getch("par_imagcube","s",&par_imagcube)) strcpy(par_imagcube," ");
   if (0==getch("par_gradient","s",&par_gradient)) strcpy(par_gradient," ");
   if (0==getch("par_residual","s",&par_residual)) strcpy(par_residual," ");
   if (0==getch("par_gradprcs","s",&par_gradprcs)) strcpy(par_gradprcs," ");
   if (0==getch("par_initfile","s",&par_initfile)) strcpy(par_initfile," ");
   
   if (0==getch("nsb"  ,"i",&nsb  )) nsb   = 1  ;
   if (0==getch("nsrc" ,"i",&nsrc )) nsrc  = 3  ;
   if (0==getch("niter","i",&niter)) niter = 1  ;
   if (0==getch("alph" ,"f",&alph )) alph  = 20.;
   if (0==getch("masks","i",&masks)) masks = 0  ;
   if (0==getch("check","i",&check)) check = 0  ;
   
   if (nrank!=nsb){
      fprintf(stderr, "ERROR: nrank != nsb,  %d %d \n", nrank, nsb);
      MPI_FINALIZE();
   }
   
   
   sprintf(numstr, "%d", irank+1);
   strcpy(shot_string, suffix); strcat(shot_string, numstr);
   
   strcpy(fnbimg_orig, resdir); strcat(fnbimg_orig, fnbimg); 
   strcpy(fnbimg_temp, tmpdir); strcat(fnbimg_temp, fnbimg); strcat(fnbimg_temp, shot_string);
   
   strcpy(fnfobj_orig, resdir); strcat(fnfobj_orig, fnfobj);
   strcpy(fnfobj_temp, tmpdir); strcat(fnfobj_temp, fnfobj); strcat(fnfobj_temp, shot_string);
   
   strcpy(fngrdo_orig, resdir); strcat(fngrdo_orig, fngrdo);
   strcpy(fngrdo_temp, tmpdir); strcat(fngrdo_temp, fngrdo); strcat(fngrdo_temp, shot_string);
   
   strcpy(fngrdp_orig, resdir); strcat(fngrdp_orig, fngrdp);
   strcpy(fngrdp_temp, tmpdir); strcat(fngrdp_temp, fngrdp); strcat(fngrdp_temp, shot_string);
   
   strcpy(fnsrch_orig, resdir); strcat(fnsrch_orig, fnsrch);
   strcpy(fnsrch_temp, tmpdir); strcat(fnsrch_temp, fnsrch); strcat(fnsrch_temp, shot_string);
   
   strcpy(fnmmov_orig, resdir); strcat(fnmmov_orig, fnmmov);
   strcpy(fnmmov_temp, tmpdir); strcat(fnmmov_temp, fnmmov); strcat(fnmmov_temp, shot_string);
   
   strcpy(fnfmov_orig, resdir); strcat(fnfmov_orig, fnfmov);
   strcpy(fnfmov_temp, tmpdir); strcat(fnfmov_temp, fnfmov); strcat(fnfmov_temp, shot_string);
   
   strcpy(fnimsk_orig, datdir); strcat(fnimsk_orig, fnimsk);
   strcpy(fnimsk_temp, tmpdir); strcat(fnimsk_temp, fnimsk); strcat(fnimsk_temp, shot_string);
   
   strcpy(fngmsk_orig, datdir); strcat(fngmsk_orig, fngmsk);
   strcpy(fngmsk_temp, tmpdir); strcat(fngmsk_temp, fngmsk); strcat(fngmsk_temp, shot_string);
   
   strcpy(fncsou_orig, datdir); strcat(fncsou_orig, fncsou); strcat(fncsou_orig, shot_string);
   strcpy(fncsou_temp, tmpdir); strcat(fncsou_temp, fncsou); strcat(fncsou_temp, shot_string);
   
   strcpy(fncrec_orig, datdir); strcat(fncrec_orig, fncrec); strcat(fncrec_orig, shot_string);
   strcpy(fncrec_temp, tmpdir); strcat(fncrec_temp, fncrec); strcat(fncrec_temp, shot_string);
   
   strcpy(fnbvel_orig, datdir); strcat(fnbvel_orig, fnbvel);
   strcpy(fnbvel_temp, tmpdir); strcat(fnbvel_temp, fnbvel); strcat(fnbvel_temp, shot_string);
   
   ////////////////////////////
   // copy source to all nodes
   ////////////////////////////
   create_cpy_one2all(cpy_csou, tmpdir, fncsou_orig, fncsou_temp);
   create_cpy_one2all(cpy_crec, tmpdir, fncrec_orig, fncrec_temp);
   create_cpy_one2all(cpy_bvel, tmpdir, fnbvel_orig, fnbvel_temp);
   create_cpy_one2all(cpy_imsk, tmpdir, fnimsk_orig, fnimsk_temp);
   create_cpy_one2all(cpy_gmsk, tmpdir, fngmsk_orig, fngmsk_temp);
   
   create_cpy_all2one(cpy_bimg, fnbimg_orig, fnbimg_temp);
   create_cpy_all2one(cpy_grdo, fngrdo_orig, fngrdo_temp);
   create_cpy_all2one(cpy_grdp, fngrdp_orig, fngrdp_temp);
   create_cpy_all2one(cpy_srch, fnsrch_orig, fnsrch_temp);
   create_cpy_all2one(cpy_fobj, fnfobj_orig, fnfobj_temp);
   
   create_cpy_all2one(cpy_mmov, fnmmov_orig, fnmmov_temp);
   create_cpy_all2one(cpy_fmov, fnfmov_orig, fnfmov_temp);
   
   create_cmd_imagcube(cmd_imagcube, bindir, tmpdir, fncsou_temp, fncrec_temp, fnbvel_temp, fnbimg_temp, par_imagcube);
   create_cmd_residual(cmd_residual, bindir, tmpdir, fnbimg_temp, fnfobj_temp, fnimsk_temp, par_residual);
   create_cmd_gradient(cmd_gradinto, bindir, tmpdir, fncsou_temp, fncrec_temp, fnbvel_temp, fnbimg_temp, fngrdo_temp, par_gradient);
   create_cmd_gradient(cmd_gradintp, bindir, tmpdir, fncsou_temp, fncrec_temp, fnbvel_temp, fnbimg_temp, fngrdp_temp, par_gradient);
   create_cmd_gradprcs(cmd_grdoprcs, bindir, tmpdir, fngrdo_temp, fngmsk_temp, fnbimg_temp, par_gradprcs);
   create_cmd_gradprcs(cmd_grdpprcs, bindir, tmpdir, fngrdp_temp, fngmsk_temp, fnbimg_temp, par_gradprcs);
   create_cmd_srchdrct(cmd_sdsdstep, bindir, tmpdir, fnsrch_temp, fngrdo_temp, fngrdp_temp, " method=sdstep rstart=n");
   create_cmd_srchdrct(cmd_sdcgstep, bindir, tmpdir, fnsrch_temp, fngrdo_temp, fngrdp_temp, " method=cgstep rstart=n");
   create_cmd_initfile(cmd_initfile, bindir, tmpdir, fnmmov_temp, fnfmov_temp, par_initfile);
   /*
   fprintf(stderr, "%s\n", cmd_imagcube);
   fprintf(stderr, "%s\n", cmd_residual);
   fprintf(stderr, "%s\n", cmd_gradinto);
   fprintf(stderr, "%s\n", cmd_gradintp);
   fprintf(stderr, "%s\n", cmd_grdoprcs);
   fprintf(stderr, "%s\n", cmd_grdpprcs);
   fprintf(stderr, "%s\n", cmd_sdsdstep);
   fprintf(stderr, "%s\n", cmd_sdcgstep);
   */
   
   
   f = (float *) malloc(sizeof(float)*nsrc);
   
   // copy sources
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cpy_csou)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_csou); MPI_Finalize(); exit(1);}
   
   // copy receivers
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cpy_crec)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_crec); MPI_Finalize(); exit(1);}
   
   // copy background velocity
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cpy_bvel)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_bvel); MPI_Finalize(); exit(1);}
   
   if (masks) {
      MPI_Barrier(MPI_COMM_WORLD);
      if (0!=system(cpy_imsk)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_imsk); MPI_Finalize(); exit(1);}
      MPI_Barrier(MPI_COMM_WORLD);  
      if (0!=system(cpy_gmsk)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_gmsk); MPI_Finalize(); exit(1);}
   }
   
   // compute background image
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cmd_imagcube)) {fprintf(stderr, "irank=%d, %s\n", irank, cmd_imagcube); MPI_Finalize(); exit(1);}
   
   MPI_Barrier(MPI_COMM_WORLD);
   
   // collect images
   auxinout(fnbimg_temp);
   hinaxis(fnbimg_temp, &ahx_igrid, 1);
   hinaxis(fnbimg_temp, &ahy_igrid, 2);
   hinaxis(fnbimg_temp, &ax_igrid , 3);
   hinaxis(fnbimg_temp, &ay_igrid , 4);
   hinaxis(fnbimg_temp, &az_igrid , 5);
   auxclose(fnbimg_temp);
   
   nsmp_igrid = ahx_igrid.n*ahy_igrid.n*ax_igrid.n*ay_igrid.n*az_igrid.n;
   
   btmp = (float *) malloc(sizeof(float)*nsmp_igrid);
   bimg = (float *) malloc(sizeof(float)*nsmp_igrid);
   
   auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); sreed(fnbimg_temp, btmp, 4*nsmp_igrid); auxclose(fnbimg_temp);
   MPI_Barrier(MPI_COMM_WORLD);
   MPI_Allreduce(btmp,bimg,nsmp_igrid,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
   auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); srite(fnbimg_temp, bimg, 4*nsmp_igrid); auxclose(fnbimg_temp);
   
   if (check){
      if (irank==0){
         if (0!=system(cpy_bimg)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_bimg); MPI_Finalize(); exit(1);}
      }
   }
   
   // compute residual
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cmd_residual)) {fprintf(stderr, "irank=%d, %s\n", irank, cmd_residual); MPI_Finalize(); exit(1);}
   
   // read objective functon value
   auxinout(fnfobj_temp); sseek(fnfobj_temp, 0, 0); sreed(fnfobj_temp, &fobj, 4); auxclose(fnfobj_temp);
   
   // compute gradient
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cmd_gradinto)) {fprintf(stderr, "irank=%d, %s\n", irank, cmd_gradinto); MPI_Finalize(); exit(1);}
   
   MPI_Barrier(MPI_COMM_WORLD);
   
   // collect the gradient from all nodes
   auxinout(fngrdo_temp);
   hinaxis(fngrdo_temp, &ax_vgrid, 1);
   hinaxis(fngrdo_temp, &ay_vgrid, 2);
   hinaxis(fngrdo_temp, &az_vgrid, 3);
   auxclose(fngrdo_temp);
   
   nsmp_vgrid = ax_vgrid.n*ay_vgrid.n*az_vgrid.n;
   
   grdo = (float *) malloc(sizeof(float)*nsmp_vgrid);
   grdp = (float *) malloc(sizeof(float)*nsmp_vgrid);
   srch = (float *) malloc(sizeof(float)*nsmp_vgrid);
   
   auxinout(fngrdo_temp); sseek(fngrdo_temp, 0, 0); sreed(fngrdo_temp, grdo, 4*nsmp_vgrid); auxclose(fngrdo_temp);
   MPI_Barrier(MPI_COMM_WORLD);
   MPI_Allreduce(grdo,grdp,nsmp_vgrid,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD); //ALLreduce means reduce and distribute them back to each node.
   auxinout(fngrdo_temp); sseek(fngrdo_temp, 0, 0); srite(fngrdo_temp, grdp, 4*nsmp_vgrid); auxclose(fngrdo_temp);
   
   // smooth gradient
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cmd_grdoprcs)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_grdoprcs); MPI_Finalize(); exit(1);}
   
   if (check){
      if (irank==0){
         if (0!=system(cpy_grdo)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_grdo); MPI_Finalize(); exit(1);}
      }
   }
   
   // search direction
   MPI_Barrier(MPI_COMM_WORLD);
   if (0!=system(cmd_sdsdstep)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_sdsdstep); MPI_Finalize(); exit(1);}
   
   if (check){
      if (irank==0){
         if (0!=system(cpy_srch)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_srch); MPI_Finalize(); exit(1);}
      }
   }
   
   
   aiter.n = niter+1;
   
   if (irank==0){
      auxinout(fnmmov_temp);
      houaxis(fnmmov_temp, &ax_vgrid, 1);
      houaxis(fnmmov_temp, &ay_vgrid, 2);
      houaxis(fnmmov_temp, &az_vgrid, 3);
      houaxis(fnmmov_temp, &aiter   , 4);
      auxclose(fnmmov_temp);
    
      auxinout(fnfmov_temp);
      houaxis(fnfmov_temp, &aiter   , 1);
      auxclose(fnfmov_temp);
   
      auxinout(fnbvel_temp); sseek(fnbvel_temp, 0, 0); sreed(fnbvel_temp, grdo , 4*nsmp_vgrid); auxclose(fnbvel_temp);
      auxinout(fnmmov_temp); sseek(fnmmov_temp, 0, 0); srite(fnmmov_temp, grdo , 4*nsmp_vgrid);
      auxinout(fnfmov_temp); sseek(fnfmov_temp, 0, 0); srite(fnfmov_temp, &fobj, 4           );
   }
   
   MPI_Barrier(MPI_COMM_WORLD);
   
   if (irank==0){
      fprintf(stderr, "Begin iteration...\n");
      fprintf(stderr, "iter = %d, fobj = %f,  alph = %f\n", 0, fobj, alph);
   }
   
   sfac = 0.5*(nsrc+1);
   
   for (iter=1;iter<=niter;iter++){
   
       auxinout(fnbvel_temp); sseek(fnbvel_temp, 0, 0); sreed(fnbvel_temp, grdo, 4*nsmp_vgrid); auxclose(fnbvel_temp);
       auxinout(fnsrch_temp); sseek(fnsrch_temp, 0, 0); sreed(fnsrch_temp, srch, 4*nsmp_vgrid); auxclose(fnsrch_temp);
   
       norm = fabs(srch[0]);
       for (ismp=0;ismp<nsmp_vgrid;ismp++){
           if (fabs(srch[ismp])>=norm) norm = fabs(srch[ismp]);
       }
   
       for (ismp=0;ismp<nsmp_vgrid;ismp++) srch[ismp] = srch[ismp]/norm;
   
       for (isrc=0;isrc<nsrc;isrc++){
   //      perturb velocity field
           for (ismp=0;ismp<nsmp_vgrid;ismp++) grdp[ismp] = grdo[ismp]+alph*(isrc+1)*srch[ismp];
   
           auxinout(fnbvel_temp); sseek(fnbvel_temp, 0, 0); srite(fnbvel_temp, grdp, 4*nsmp_vgrid); auxclose(fnbvel_temp);
   
   //      perform migration on each node
           MPI_Barrier(MPI_COMM_WORLD);
           if (0!=system(cmd_imagcube)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_imagcube); MPI_Finalize(); exit(1);}
   
   //      collect images from each node
           auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); sreed(fnbimg_temp, btmp, 4*nsmp_igrid); auxclose(fnbimg_temp);
           MPI_Barrier(MPI_COMM_WORLD);
           MPI_Allreduce(btmp,bimg,nsmp_igrid,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
           auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); srite(fnbimg_temp, bimg, 4*nsmp_igrid); auxclose(fnbimg_temp);
   
   //      compute objective function
           MPI_Barrier(MPI_COMM_WORLD);
           if (0!=system(cmd_residual)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_residual); MPI_Finalize(); exit(1);}
   
           auxinout(fnfobj_temp); sseek(fnfobj_temp, 0, 0); sreed(fnfobj_temp, &f[isrc], 4); auxclose(fnfobj_temp);
   
           MPI_Barrier(MPI_COMM_WORLD);
       }
   
       fopt = f[0];
       iopt = 0;
       for (isrc=0;isrc<nsrc;isrc++){
           if (f[isrc]<=fopt){
              iopt = isrc;
              fopt = f[isrc];
           }
       }
   
       if (f[iopt]<=fobj){
          for (ismp=0;ismp<nsmp_vgrid;ismp++) grdp[ismp] = grdo[ismp]+alph*(iopt+1)*srch[ismp];
          alph = alph*(iopt+1)/sfac;
       }
       else{
          for (ismp=0;ismp<nsmp_vgrid;ismp++) grdp[ismp] = grdo[ismp];
          alph = alph*0.5;
       }
   
       auxinout(fnbvel_temp); sseek(fnbvel_temp, 0, 0); srite(fnbvel_temp, grdp, 4*nsmp_vgrid); auxclose(fnbvel_temp);
   
   //  compute background image
       MPI_Barrier(MPI_COMM_WORLD);
       if (0!=system(cmd_imagcube)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_imagcube); MPI_Finalize(); exit(1);}
       auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); sreed(fnbimg_temp, btmp, 4*nsmp_igrid); auxclose(fnbimg_temp);
       MPI_Barrier(MPI_COMM_WORLD);
       MPI_Allreduce(btmp,bimg,nsmp_igrid,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
       auxinout(fnbimg_temp); sseek(fnbimg_temp, 0, 0); srite(fnbimg_temp, bimg, 4*nsmp_igrid); auxclose(fnbimg_temp);
   
       if (check){
          if (irank==0){
             if (0!=system(cpy_bimg)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_bimg); MPI_Finalize(); exit(1);}
          }
       }
   
   //  compute the residual
       MPI_Barrier(MPI_COMM_WORLD);
       if (0!=system(cmd_residual)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_residual); MPI_Finalize(); exit(1);}
   
   //  get the objective function value 
       auxinout(fnfobj_temp); sseek(fnfobj_temp, 0, 0); sreed(fnfobj_temp, &fobj, 4); auxclose(fnfobj_temp);
   
   //  compute the gradient
       MPI_Barrier(MPI_COMM_WORLD);
       if (0!=system(cmd_gradintp)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_gradintp); MPI_Finalize(); exit(1);}
       auxinout(fngrdp_temp); sseek(fngrdp_temp, 0, 0); sreed(fngrdp_temp, grdo, 4*nsmp_vgrid); auxclose(fngrdp_temp);
       MPI_Barrier(MPI_COMM_WORLD);
       MPI_Allreduce(grdo,grdp,nsmp_vgrid,MPI_FLOAT,MPI_SUM,MPI_COMM_WORLD);
       auxinout(fngrdp_temp); sseek(fngrdp_temp, 0, 0); srite(fngrdp_temp, grdp, 4*nsmp_vgrid); auxclose(fngrdp_temp);
   
   //  smooth the gradient
       MPI_Barrier(MPI_COMM_WORLD);
       if (0!=system(cmd_grdpprcs)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_grdpprcs); MPI_Finalize(); exit(1);}
   
       if (check){
          if (irank==0){
             if (0!=system(cpy_grdp)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_grdp); MPI_Finalize(); exit(1);}
          }
       }
   
   //  find the search direction
       MPI_Barrier(MPI_COMM_WORLD);
       if (0!=system(cmd_sdcgstep)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cmd_sdcgstep); MPI_Finalize(); exit(1);}
   
       if (check){
          if (irank==0){
             if (0!=system(cpy_srch)) {fprintf(stderr, "irank=%d, %s\n", irank, cpy_srch); MPI_Finalize(); exit(1);}
          }
       }
   
   //  write out model and fobj histories
       if (irank==0){
          fprintf(stderr, "iter = %d, fobj = %f,  alph = %f\n", iter, fobj, alph);
          auxinout(fnbvel_temp); sseek(fnbvel_temp, 0, 0); sreed(fnbvel_temp, grdo , 4*nsmp_vgrid); auxclose(fnbvel_temp);
          srite(fnmmov_temp, grdo , 4*nsmp_vgrid);
          srite(fnfmov_temp, &fobj, 4           );
          if (0!=system(cpy_mmov)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cpy_mmov); MPI_Finalize(); exit(1);}
          if (0!=system(cpy_fmov)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cpy_fmov); MPI_Finalize(); exit(1);}
       } 
   
       MPI_Barrier(MPI_COMM_WORLD);
   }
   
   
   if (irank==0){
      if (0!=system(cpy_mmov)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cpy_mmov); MPI_Finalize(); exit(1);}
      if (0!=system(cpy_fmov)) {fprintf(stderr, "ERROR: irank=%d, %s\n", irank, cpy_fmov); MPI_Finalize(); exit(1);}
   }
   
   MPI_Barrier(MPI_COMM_WORLD);
   
   free(btmp);
   free(bimg);
   free(grdo);
   free(grdp);
   free(srch);
   
   if (irank==0){
      fprintf(stderr, "********************************\n");
      fprintf(stderr, " FINISHED TOMOGRAPHIC INVERSION \n");
      fprintf(stderr, "********************************\n");
   }
   
   MPI_Finalize();
   return 0;
}




