program main
  use base_ioutil_mod
  use encode_fileio_mod
  implicit none


  type(axis)                             :: asx, asy, agx, agy, aws
  type(axis)                             :: asx_chk, asy_chk, aws_chk
  complex, dimension(:,:,:), allocatable :: crec, wfdr, efnc

  integer                                :: isx, isy, iws
  character(len=256)                     :: crec_, wfdr_, efnc_
  character(len=6)                       :: mode

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  crec_ = "crec"
  wfdr_ = "wfdr"
  efnc_ = "efnc"

  call from_param("mode", mode, "decode")

  call auxinout(crec_)
  call auxinout(wfdr_)
  call auxinout(efnc_)

  call hinaxis(efnc_, asx_chk, 1)
  call hinaxis(efnc_, asy_chk, 2)
  call hinaxis(efnc_, aws_chk, 3)

  if (mode=="encode") then
     call hinaxis(crec_, agx, 1)
     call hinaxis(crec_, agy, 2)
     call hinaxis(crec_, aws, 3)
     call hinaxis(crec_, asx, 4)
     call hinaxis(crec_, asy, 5)
     if (asx_chk%n/=asx%n.or.asx_chk%o/=asx%o.or.asx_chk%d/=asx%d) call seperr("error: asx_chk /= asx")
     if (asy_chk%n/=asy%n.or.asy_chk%o/=asy%o.or.asy_chk%d/=asy%d) call seperr("error: asy_chk /= asy")
     if (aws_chk%n/=aws%n.or.aws_chk%o/=aws%o.or.aws_chk%d/=aws%d) call seperr("error: aws_chk /= aws")

     call houaxis(wfdr_, agx, 1)
     call houaxis(wfdr_, agy, 2)
     call houaxis(wfdr_, aws, 3) 
     call auxputch("esize", "i", 8, wfdr_)
  end if

  if (mode=="decode") then
     call hinaxis(wfdr_, agx, 1)
     call hinaxis(wfdr_, agy, 2)
     call hinaxis(wfdr_, aws, 3)
     if (aws_chk%n/=aws%n.or.aws_chk%o/=aws%o.or.aws_chk%d/=aws%d) call seperr("error: aws_chk /= aws")
     asx = asx_chk
     asy = asy_chk
     
     call houaxis(crec_, agx, 1)
     call houaxis(crec_, agy, 2)
     call houaxis(crec_, aws, 3)
     call houaxis(crec_, asx, 4)
     call houaxis(crec_, asy, 5)
     call auxputch("esize", "i", 8, crec_)
  end if

write(0,*)agx%n,agy%n,aws%n,asx%n,asy%n

  allocate(crec(agx%n,agy%n,aws%n))
  allocate(wfdr(agx%n,agy%n,aws%n))
  allocate(efnc(asx%n,asy%n,aws%n))


  call encode_fileio_efns(efnc,asx%n,asy%n,aws%n,1,1,1,1,efnc_,"reed")

  crec = 0.
  wfdr = 0.

  if (mode=="decode") call sep_read(wfdr, wfdr_)

  do isx=1, asx%n
  do isy=1, asy%n

     if (mode=="encode") then
        call encode_fileio_crec(crec, agx%n, agy%n, aws%n, asx%n, asy%n, isx, isy, crec_, "reed")
        do iws=1, aws%n
           wfdr(:,:,iws) = wfdr(:,:,iws) + efnc(isx,isy,iws)*crec(:,:,iws)
        end do
     end if

     if (mode=="decode") then
        do iws=1, aws%n
           crec(:,:,iws) = conjg(efnc(isx,isy,iws)) * wfdr(:,:,iws)
        end do
        call encode_fileio_crec(crec, agx%n, agy%n, aws%n, asx%n, asy%n, isx, isy, crec_, "rite") 
     end if

  end do
  end do

  if (mode=="encode") call sep_write(wfdr, wfdr_)


end program
