program main
  use base_ioutil_mod
  use encode_fileio_mod
  implicit none

  type(axis)                             :: asx, asy, agx, agy, aws, arx, ary, apsx, apsy
  type(axis)                             :: asx_chk, asy_chk, aws_chk
  complex, dimension(:)    , allocatable :: csou
  complex, dimension(:,:,:), allocatable :: crec
  complex, dimension(:,:,:), allocatable :: wfds
  complex, dimension(:,:,:), allocatable :: wfdr
  complex, dimension(:,:,:), allocatable :: efns
  complex, dimension(:,:,:), allocatable :: efnr 
  real                                   :: sx_min, sx_max, sy_min, sy_max
  real                                   :: gx_min, gx_max, gy_min, gy_max
  real                                   :: rx_min, rx_max, ry_min, ry_max
  real                                   :: sx, sy, wght, ws
  integer                                :: isx, isy, jsx, jsy, iws, ipsx, ipsy
  integer                                :: jgxb, jgxe, jgyb, jgye
  logical                                :: offset, encsou, outsou, outrec, wgtsou, wgtrec
  character(len=256)                     :: csou_, crec_
  character(len=256)                     :: wfds_, wfdr_
  character(len=256)                     :: efns_, efnr_

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  csou_ = "csou"
  crec_ = "crec"
  wfds_ = "wfds"
  wfdr_ = "wfdr"
  efns_ = "efns"
  efnr_ = "efnr"

  call from_param("offset", offset, .false.)
  call from_param("encsou", encsou, .true. )
  call from_param("outsou", outsou, .true. )
  call from_param("outrec", outrec, .true. )
  call from_param("wgtsou", wgtsou, .false.)
  call from_param("wgtrec", wgtrec, .false.)

  if (outsou) then
     call auxinout(csou_)
     call auxinout(wfds_)
  end if
  if (outrec) then
     call auxinout(crec_)
     call auxinout(wfdr_)
  end if

  if (outrec) then
     call hinaxis(crec_, agx, 1)
     call hinaxis(crec_, agy, 2)
     call hinaxis(crec_, aws, 3)
     call hinaxis(crec_, asx, 4)
     call hinaxis(crec_, asy, 5)
  else
     call hinaxis(csou_, aws, 3)
     call from_param("ngx",agx%n,1); call from_param("dgx",agx%d,1.); call from_param("ogx",agx%o,0.)
     call from_param("ngy",agy%n,1); call from_param("dgy",agy%d,1.); call from_param("ogy",agy%o,0.)
     call from_param("nsx",asx%n,1); call from_param("dsx",asx%d,1.); call from_param("osx",asx%o,0.)
     call from_param("nsy",asy%n,1); call from_param("dsy",asy%d,1.); call from_param("osy",asy%o,0.)
  end if

  sx_min = asx%o; sx_max = asx%o+(asx%n-1)*asx%d
  sy_min = asy%o; sy_max = asy%o+(asy%n-1)*asy%d
  gx_min = agx%o; gx_max = agx%o+(agx%n-1)*agx%d
  gy_min = agy%o; gy_max = agy%o+(agy%n-1)*agy%d

  rx_min = gx_min; rx_max = gx_max
  ry_min = gy_min; ry_max = gy_max

  if (offset) then
     gx_min = gx_min + sx_min; gx_max = gx_max + sx_max
     gy_min = gy_min + sy_min; gy_max = gy_max + sy_max
  end if

  rx_min = min(sx_min, gx_min); rx_max = max(sx_max, gx_max)
  ry_min = min(sy_min, gy_min); ry_max = max(sy_max, gy_max)
  
  arx%o = rx_min; arx%d = min(asx%d, agx%d); arx%n = 1.5+(rx_max-arx%o)/arx%d
  ary%o = ry_min; ary%d = min(asy%d, agy%d); ary%n = 1.5+(ry_max-ary%o)/ary%d

write(0,*)"ngx, ngy, nsx, nsy, nws", agx%n, agy%n, asx%n, asy%n, aws%n
write(0,*)"dgx, dgy, dsx, dsy, dws", agx%d, agy%d, asx%d, asy%d, aws%d
write(0,*)"ogx, ogy, osx, osy, ows", agx%o, agy%o, asx%o, asy%o, aws%o


  if (encsou) then

     call auxinout(efns_)
     call auxinout(efnr_)

     call hinaxis(efns_, asx_chk, 1) 
     call hinaxis(efns_, asy_chk, 2)
     call hinaxis(efns_, aws_chk, 3)
     call hinaxis(efns_, apsx   , 4)
     call hinaxis(efns_, apsy   , 5)

     if (asx_chk%n/=asx%n) call seperr("error: asx_chk /= asx")
     if (asy_chk%n/=asy%n) call seperr("error: asy_chk /= asy")
     if (aws_chk%n/=aws%n.or.aws_chk%o/=aws%o.or.aws_chk%d/=aws%d) call seperr("error: aws_chk /= aws")

!    if encoded source wavefield is required for output
!    --------------------------------------------------     
     if (outsou) then
        call houaxis(wfds_, arx , 1)
        call houaxis(wfds_, ary , 2)
        call houaxis(wfds_, aws , 3)
        if (asx%n==1) then
           call houaxis(wfds_, asx, 4)
        else
           call houaxis(wfds_, apsx, 4)
        end if
        if (asy%n==1) then
           call houaxis(wfds_, asy, 5)
        else
           call houaxis(wfds_, apsy, 5)
        end if
        call auxputch("esize", "i", 8, wfds_)
        allocate(csou(aws%n)) 
        allocate(wfds(arx%n,ary%n,aws%n))
        call sep_read(csou, csou_)
     end if

     if (outrec) then 
        call houaxis(wfdr_, arx , 1)
        call houaxis(wfdr_, ary , 2)
        call houaxis(wfdr_, aws , 3)
        if (asx%n==1) then
           call houaxis(wfdr_, asx, 4)
        else  
           call houaxis(wfdr_, apsx, 4)
        end if
        if (asy%n==1) then
           call houaxis(wfdr_, asy, 5)
        else
           call houaxis(wfdr_, apsy, 5)
        end if 
        call auxputch("esize", "i", 8, wfdr_)
        allocate(crec(agx%n,agy%n,aws%n))
        allocate(wfdr(arx%n,ary%n,aws%n))
     end if

     allocate(efns(asx%n,asy%n,aws%n))

     do ipsy=1, apsy%n
     do ipsx=1, apsx%n
        call encode_fileio_efns(efns,asx%n,asy%n,aws%n,apsx%n,apsy%n,ipsx,ipsy,efns_,"reed")
        if (outsou) wfds = 0. 
        if (outrec) wfdr = 0. 
        do isy=1, asy%n; sy = asy%o+(isy-1)*asy%d; jsy = 1.5+(sy-ary%o)/ary%d
        do isx=1, asx%n; sx = asx%o+(isx-1)*asx%d; jsx = 1.5+(sx-arx%o)/arx%d
           gx_min = agx%o; gx_max = agx%o+(agx%n-1)*agx%d
           gy_min = agy%o; gy_max = agy%o+(agy%n-1)*agy%d
           if (offset) then
              gx_min = gx_min + sx; gx_max = gx_max + sx
              gy_min = gy_min + sy; gy_max = gy_max + sy
           end if 
           jgxb = 1.5+(gx_min-arx%o)/arx%d; jgxe = 1.5+(gx_max-arx%o)/arx%d
           jgyb = 1.5+(gy_min-ary%o)/ary%d; jgye = 1.5+(gy_max-ary%o)/ary%d 
           if (outrec) call encode_fileio_crec(crec, agx%n, agy%n, aws%n, asx%n, asy%n, isx, isy, crec_, "reed")
           do iws=1, aws%n
              ws = aws%o + (iws-1)*aws%d
              if (apsy%n>1 .and. apsx%n>1) then
                 wght = abs(ws)
              else
                 wght = sqrt(abs(ws))
              end if

              if (outsou) then
                 if (wgtsou) then
                    wfds(jsx,jsy,iws) = wfds(jsx,jsy,iws) + csou(iws)*efns(isx,isy,iws)*wght
                 else
                    wfds(jsx,jsy,iws) = wfds(jsx,jsy,iws) + csou(iws)*efns(isx,isy,iws)
                 end if
              end if

              if (outrec) then
                 if (wgtrec) then
                    wfdr(jgxb:jgxe,jgyb:jgye,iws) = wfdr(jgxb:jgxe,jgyb:jgye,iws) + crec(:,:,iws)*efns(isx,isy,iws)*wght
                 else
                    wfdr(jgxb:jgxe,jgyb:jgye,iws) = wfdr(jgxb:jgxe,jgyb:jgye,iws) + crec(:,:,iws)*efns(isx,isy,iws)
                 end if
              end if

           end do 
        end do
        end do
        if (outsou) call sep_write(wfds, wfds_)
        if (outrec) call sep_write(wfdr, wfdr_)
     end do 
     end do

  end if

end program
