module encode_fileio_mod
  use sep
  implicit none

  integer, external, private :: sreed_window, srite_window
contains

  subroutine encode_fileio_crec(crec, ngx, ngy, nws, nsx, nsy, indsx, indsy, filetag, flag)
  complex, dimension(:,:,:) :: crec
  integer                   :: ngx, ngy, nws, nsx, nsy
  integer                   :: indsx, indsy
  character(len=*)          :: filetag
  character(len=4)          :: flag

  integer, dimension(5)     :: n_cube, j_wind, n_wind, f_wind
  integer                   :: n_dim_cube, err

  n_dim_cube = 5
  n_cube = (/ngx, ngy, nws, nsx, nsy/)
  j_wind = (/1, 1, 1, 1, 1/)
  n_wind = (/ngx, ngy, nws, 1, 1/)
  f_wind = (/0, 0, 0, indsx-1, indsy-1/)

  if (flag == "reed") then
     err = sreed_window(filetag,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,crec)
  else if (flag == "rite") then
     err = srite_window(filetag,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,crec)
  else
     call seperr("error")
  end if
  return
  end subroutine

  subroutine encode_fileio_efns(efns,nsx,nsy,nws,npsx,npsy,ipsx,ipsy,filetag,flag)
    complex, dimension(:,:,:) :: efns
    integer                   :: nsx,nsy,nws,npsx,npsy,ipsx,ipsy
    character(len=*)          :: filetag
    character(len=4)          :: flag

    integer, dimension(5)     :: n_cube, j_wind, n_wind, f_wind
    integer                   :: n_dim_cube, err

    n_dim_cube = 5
    n_cube = (/nsx, nsy, nws, npsx, npsy/)
    j_wind = (/1, 1, 1, 1, 1/)
    n_wind = (/nsx, nsy, nws, 1, 1/)
    f_wind = (/0, 0, 0, ipsx-1, ipsy-1/)

    if (flag == "rite") then
       err = srite_window(filetag,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,efns)
       efns = 0.
    else if (flag == "reed") then
       efns = 0.
       err = sreed_window(filetag,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,efns)
    else
       call seperr("you have to specify the flag for grns")
    end if
    return
  end subroutine

end module
