program main
  use base_ioutil_mod
  use encode_fileio_tsft_mod
  implicit none

  type(axis)                               :: asx, asy, agx, agy, ats, ato, aws, arx, ary, apsx, apsy
  real   , dimension(:,:,:)  , allocatable :: trec
  real   , dimension(:,:,:)  , allocatable :: wfdr
  real   , dimension(:,:,:,:), allocatable :: tsft
  real   , dimension(:,:)    , allocatable :: efns
  real                                     :: sx_min, sx_max, sy_min, sy_max
  real                                     :: gx_min, gx_max, gy_min, gy_max
  real                                     :: rx_min, rx_max, ry_min, ry_max
  real                                     :: sx, sy, rt_min, rt_max
  integer                                  :: isx, isy, jsx, jsy, iws, ipsx, ipsy
  integer                                  :: jgxb, jgxe, jgyb, jgye, jts, its
  logical                                  :: offset, divfrq
  character(len=256)                       :: trec_
  character(len=256)                       :: wfdr_
  character(len=256)                       :: efns_tsft_

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  trec_ = "trec"
  wfdr_ = "wfdr"
  efns_tsft_ = "efns_tsft"

  call from_param("offset", offset, .false.)
  call from_param("rt_min", rt_min, 0.2    )
  call from_param("rt_max", rt_max, 2.2    )
  call auxinout(trec_)
  call auxinout(wfdr_)

  call hinaxis(trec_, ats, 1)
  call hinaxis(trec_, agx, 2)
  call hinaxis(trec_, agy, 3)
  call hinaxis(trec_, asx, 4)
  call hinaxis(trec_, asy, 5)

  sx_min = asx%o; sx_max = asx%o+(asx%n-1)*asx%d
  sy_min = asy%o; sy_max = asy%o+(asy%n-1)*asy%d
  gx_min = agx%o; gx_max = agx%o+(agx%n-1)*agx%d
  gy_min = agy%o; gy_max = agy%o+(agy%n-1)*agy%d

  rx_min = gx_min; rx_max = gx_max
  ry_min = gy_min; ry_max = gy_max

  if (offset) then
     gx_min = gx_min + sx_min; gx_max = gx_max + sx_max
     gy_min = gy_min + sy_min; gy_max = gy_max + sy_max
  end if

  rx_min = min(sx_min, gx_min); rx_max = max(sx_max, gx_max)
  ry_min = min(sy_min, gy_min); ry_max = max(sy_max, gy_max)
  
  arx%o = rx_min; arx%d = min(asx%d, agx%d); arx%n = 1.5+(rx_max-arx%o)/arx%d
  ary%o = ry_min; ary%d = min(asy%d, agy%d); ary%n = 1.5+(ry_max-ary%o)/ary%d

  call auxinout(efns_tsft_)
  call hinaxis(efns_tsft_, apsx, 3)
  call hinaxis(efns_tsft_, apsy, 4)

  allocate(efns(asx%n,asy%n))
  allocate(tsft(asx%n,asy%n,apsx%n,apsy%n))

  do ipsy=1, apsy%n
  do ipsx=1, apsx%n
     call encode_fileio_efns_tsft(efns,asx%n,asy%n,apsx%n,apsy%n,ipsx,ipsy,efns_tsft_,"reed")
     do isy=1, asy%n
     do isx=1, asx%n
        tsft(isx,isy,ipsx,ipsy) = efns(isx,isy)
     end do 
     end do
  end do
  end do 

  ato   = ats
  ato%n = ats%n+(maxval(tsft)-ats%o)/ats%d+1.5

write(0,*)"max tsft", maxval(tsft), minval(tsft)
write(0,*)"ato", ato

  call houaxis(wfdr_, ato , 1)
  call houaxis(wfdr_, arx , 2)
  call houaxis(wfdr_, ary , 3)
  call houaxis(wfdr_, apsx, 4)
  call houaxis(wfdr_, apsy, 5)
  allocate(trec(ats%n,agx%n,agy%n))
  allocate(wfdr(ato%n,arx%n,ary%n))

  do ipsy=1, apsy%n
  do ipsx=1, apsx%n
     wfdr = 0. 
     do isy=1, asy%n; sy = asy%o+(isy-1)*asy%d; jsy = 1.5+(sy-ary%o)/ary%d
     do isx=1, asx%n; sx = asx%o+(isx-1)*asx%d; jsx = 1.5+(sx-arx%o)/arx%d
        gx_min = agx%o
        gx_max = agx%o+(agx%n-1)*agx%d
        if (offset) then
           gx_min = gx_min + sx; gx_max = gx_max + sx
           gy_min = gy_min + sy; gy_max = gy_max + sy
        end if 
        jgxb = 1.5+(gx_min-arx%o)/arx%d; jgxe = 1.5+(gx_max-arx%o)/arx%d
        jgyb = 1.5+(gy_min-ary%o)/ary%d; jgye = 1.5+(gy_max-ary%o)/ary%d 

        jts = (tsft(isx,isy,ipsx,ipsy)-ato%o)/ato%d+1.5

        call sep_read(trec, trec_)
!        do its=1, ats%n
!           wfdr(jts,jgxb:jgxe,jgyb:jgye) = wfdr(jts,jgxb:jgxe,jgyb:jgye) + trec(its,:,:)
!        end do 

         wfdr(jts:ats%n+jts-1,jgxb:jgxe,jgyb:jgye) = wfdr(jts:ats%n+jts-1,jgxb:jgxe,jgyb:jgye) + trec 

     end do
     end do
     call sep_write(wfdr, wfdr_)
  end do 
  end do


end program
