!! preprocessing the Green's functions
!! such that they are suitable for different domains
!! e.g., encoded source domain, encoded receiver domain
!! and simultaneously encoded source and receiver domain
!! ADVANTAGE   : might be faster and easy to code
!! DISADVANTAGE: requires more disk storage...
module hesdct_greens_mod
  implicit none

contains


  integer function hesdct_greens_init() result(stat)
  end function

  integer function hesdct_greens_oper() result(stat)
  end function



  subroutine hesdct_shtpro()
    do ish=1, dgrid%nsh
       do itr=1, dgrid%ntr
          index_gx = hgrid%index_datgre_rec(1, itr)
          index_gy = hgrid%index_datgre_rec(2, itr)
          if (index_gx < 1 .or. index_gx > ndim1) cycle
          if (index_gy < 1 .or. index_gy > ndim2) cycle
          greens_rec_mul = greens(index_gx, index_gy, jxu_modl, jyu_modl, index_z_modl) &
                         * conjg(greens(index_gx, index_gy, jxu_offd, jyu_offd, index_z_offd))
            greens_rec_sum = greens_rec_sum + greens_rec_mul
       end do
    end do
  end subroutine

  subroutine hesdct_encsou()
  end subroutine

!  subroutine hesdct_encrec()
!  end subroutine

!  subroutine hesdct_encsim()
!  end subroutine

end module
