program main
  use sep
  use base_struct_mod
  use base_ioutil_mod
  use hesdct_fileio_mod
  implicit none

  type(acq_mask)                        :: amask
  type(axis)                            :: asx, asy, agx, agy
  integer                               :: isx, isy, igx, igy
  integer                               :: jsx, jsy, jgx, jgy
  real, dimension(:,:,:,:), allocatable :: mask
  real                                  :: sx_min, sy_min, sx_max, sy_max
  real                                  :: gx_min, gy_min, gx_max, gy_max
  real                                  :: rx_min, ry_min, rx_max, ry_max
  real                                  :: sx, sy, gx, gy, offx, offy
  logical                               :: offset
  character(len=256)                    :: mask_

  mask_ = "mask"

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call auxinout(mask_)

  call from_param("nsx", asx%n, 1); call from_param("dsx", asx%d, 1.); call from_param("osx", asx%o, 0.)
  call from_param("nsy", asy%n, 1); call from_param("dsy", asy%d, 1.); call from_param("osy", asy%o, 0.)
  call from_param("ngx", agx%n, 1); call from_param("dgx", agx%d, 1.); call from_param("ogx", agx%o, 0.)
  call from_param("ngy", agy%n, 1); call from_param("dgy", agy%d, 1.); call from_param("ogy", agy%o, 0.)

  call from_param("offset", offset, .false.)

  sx_min = asx%o; sx_max = asx%o + (asx%n-1)*asx%d
  sy_min = asy%o; sy_max = asy%o + (asy%n-1)*asy%d
  gx_min = agx%o; gx_max = agx%o + (agx%n-1)*agx%d
  gy_min = agy%o; gy_max = agy%o + (agy%n-1)*agy%d

  if (offset) then
     gx_min = gx_min + sx_min; gx_max = gx_max + sx_max
     gy_min = gy_min + sy_min; gy_max = gy_max + sy_max
  end if

  rx_min = gx_min; rx_max = gx_max
  ry_min = gy_min; ry_max = gy_max

  amask%arx%o = rx_min; amask%arx%d = agx%d; amask%arx%n = 1.5+(rx_max-rx_min)/amask%arx%d
  amask%ary%o = ry_min; amask%ary%d = agy%d; amask%ary%n = 1.5+(ry_max-ry_min)/amask%ary%d

  amask%asx%o = sx_min; amask%asx%d = asx%d; amask%asx%n = 1.5+(sx_max-sx_min)/amask%asx%d
  amask%asy%o = sy_min; amask%asy%d = asy%d; amask%asy%n = 1.5+(sy_max-sy_min)/amask%asy%d 

  allocate(mask(amask%arx%n,amask%ary%n,amask%asx%n,amask%asy%n))

write(0,*)"asx = ", amask%asx
write(0,*)"asy = ", amask%asy
write(0,*)"agx = ", agx
write(0,*)"agy = ", agy
write(0,*)"arx = ", amask%arx
write(0,*)"ary = ", amask%ary

  offx = 0. 
  offy = 0.
  mask = 0
  do isy=1, asy%n; sy=asy%o+(isy-1)*asy%d; if(offset) offy=sy; jsy=1.5+(sy-amask%asy%o)/amask%asy%d
  do isx=1, asx%n; sx=asx%o+(isx-1)*asx%d; if(offset) offx=sx; jsx=1.5+(sx-amask%asx%o)/amask%asx%d
     do igy=1, agy%n; gy=agy%o+(igy-1)*agy%d+offy; jgy=1.5+(gy-amask%ary%o)/amask%ary%d
     do igx=1, agx%n; gx=agx%o+(igx-1)*agx%d+offx; jgx=1.5+(gx-amask%arx%o)/amask%arx%d
        mask(jgx,jgy,jsx,jsy) = 1
     end do
     end do
  end do
  end do

  call houaxis(mask_, amask%arx, 1)
  call houaxis(mask_, amask%ary, 2)
  call houaxis(mask_, amask%asx, 3)
  call houaxis(mask_, amask%asy, 4)

  call auxputch("label1", "s", "rx", mask_)
  call auxputch("label2", "s", "ry", mask_)
  call auxputch("label3", "s", "sx", mask_)
  call auxputch("label4", "s", "sy", mask_) 

  call hesdct_fileio_mask(mask, amask, mask_, "rite")

end program
