#!/bin/tcsh
#PBS -N bpgom3d-imag
#PBS -l nodes=35:ppn=8
#PBS -q Q35
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -e /data/sep/tangyx/workspace/bpgom3d.born/err-imag
#PBS -o /data/sep/tangyx/workspace/bpgom3d.born/out-imag
#
cd $PBS_O_WORKDIR
#

set BINDIR=/data/sep/tangyx/bin
set DATDIR=/data/sep/tangyx/workspace/bpgom3d.born
set RESDIR=/data/sep/tangyx/workspace/bpgom3d.born
#set TMPDIR=/data/sep/tangyx/workspace/bpgom3d.born/junk
set TMPDIR=/tmp


cat ${PBS_NODEFILE} | sort | uniq > hostfile
set NPROCS=`wc -l hostfile | gawk '//{print $1}'`
echo ${NPROCS}
mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/bwi-mig4d-mpi.x bindir=${BINDIR}/ datdir=${DATDIR}/ resdir=${RESDIR}/ tmpdir=${TMPDIR}/ suffix=-shot \
fncsou=bpgom3d-csou-born-planes.H fncrec=bpgom3d-crec-born-planes-old3.H fnbvel=bpgom3d-bvel-subsample-target.H fnbimg=bpgom3d-bimg-born-hxhy.H \
nsb=35 datapath=${TMPDIR}/\
reduce=1 par_imagcube="mode=imgadj report=y memchk=n nxpad_beg=10 nxpad_end=10 nypad_beg=10 nypad_end=10 ntpx=10 ntpy=10 oper=ssfpi nvrf=4 comsou=y nws=16 image_xmin=50000 image_xmax=90000 image_ymin=65616 image_ymax=82000 stkimg=y nhx=21 ohx=-1640.4 dhx=164.04 nhy=7 ohy=-1476.36 dhy=492.12" > log-imag
