#!/bin/tcsh
#PBS -N bpgom3d-modl
#PBS -l nodes=21:ppn=8
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -e /data/sep/tangyx/workspace/bpgom3d.born/err-modl
#PBS -o /data/sep/tangyx/workspace/bpgom3d.born/out-modl
#
cd $PBS_O_WORKDIR
#

set BINDIR=/data/sep/tangyx/bin
set DATDIR=/data/sep/tangyx/workspace/bpgom3d.born
set RESDIR=/data/sep/tangyx/workspace/bpgom3d.born
#set TMPDIR=/data/sep/tangyx/workspace/bpgom3d.born/junk
set TMPDIR=/tmp

cat ${PBS_NODEFILE} | sort | uniq > hostfile
set NPROCS=`wc -l hostfile | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8
mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/bwi-mod3d-mpi.x bindir=${BINDIR}/ datdir=${DATDIR}/ resdir=${RESDIR}/ tmpdir=${TMPDIR}/ suffix=-shot \
fncsou=bpgom3d-csou-born-planes-trial.H fncrec=bpgom3d-crec-born-planes-trial.H fnbvel=bpgom3d-bvel-subsample-target.H fnbimg=bpgom3d-bimg-target-condition-sroot.H \
nsb=21 datapath=${TMPDIR}/\
par_bornmodl="mode=imgfwd report=y memchk=n nxpad_beg=10 nxpad_end=10 nypad_beg=10 nypad_end=10 ntpx=15 ntpy=15 oper=ssfpi nvrf=2 comsou=y nws=32 ngx=265 dgx=164.04 ogx=48391.8 ngy=121 dgy=164.04 ogy=63975.6 " > log-modl
