#!/bin/tcsh
#PBS -N sigsb2a-invt
#PBS -l nodes=31:ppn=8
#PBS -q Q35
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -e /data/sep/tangyx/workspace/sigsbee2a/err
#PBS -o /data/sep/tangyx/workspace/sigsbee2a/out
#
cd $PBS_O_WORKDIR
#

set BINDIR=/data/sep/tangyx/bin
set DATDIR=/data/sep/tangyx/workspace/sigsbee2a
set RESDIR=/data/sep/tangyx/workspace/sigsbee2a
#set TMPDIR=/data/sep/tangyx/workspace/sigsbee2a/junk
set TMPDIR=/tmp

cat ${PBS_NODEFILE} | sort | uniq > hostfile
set NPROCS=`wc -l hostfile | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8
mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/bwi-wet3d-mpi.x bindir=${BINDIR}/ datdir=${DATDIR}/ resdir=${RESDIR}/ tmpdir=${TMPDIR}/ suffix=-shot \
fncsou=bwi.sigsb2a.csou.born.planes-new.H fncrec=bwi.sigsb2a.crec.born.planes-new.H fnbvel=bwi.sigsb2a.bvel.target.H \
fnbimg=sigsb-bimg.H fnfobj=sigsb-fobj.H fngrdo=sigsb-grdo.H fngrdp=sigsb-grdp.H fnsrch=sigsb-srch.H \
fnimsk=sigsb2a-imsk-target.H fngmsk=sigsb2a-gmsk-target.H fnmmov=sigsb-mmov.H fnfmov=sigsb-fmov.H datapath=${TMPDIR}/\
masks=1 check=1 nsb=31 niter=30 alph=40 \
par_imagcube="mode=imgadj report=n memchk=n nxpad_beg=50 nxpad_end=50 ntpx=25 oper=foufd nvrf=5 comsou=y nws=161 image_xmin=20000 image_xmax=65000 nhx=41 ohx=-1500 " \
par_gradient="mode=tomadj report=n memchk=n nxpad_beg=50 nxpad_end=50 ntpx=25 oper=foufd nvrf=5 comsou=y nws=161 " \
par_residual="hcut=0 dsotyp=1 objeps=1.6e-06 objtyp=combos dsorms=y imgmsk=y" \
par_gradprcs="grdmsk=y gscale=n smtgrd=y smttyp=spline xk_min=20000 xk_max=65000 nxk=6 zk_min=15000 zk_max=30000 nzk=12 " > log
