program main
  use sep
  use base_wavelt_mod
  implicit none

  real, dimension(:,:,:), allocatable :: refl
  character(len=3)                    :: color
  character(len=512)                  :: fn1, fn2
  integer                             :: nx, ny, nz, ix, iy, iz, jz, jx, jy, jzb, jze, stat1, stat2, counter
  real                                :: fm, dx, dy, dz, ox, oy, oz, xc, yc, zc, z, vsalt, grad


  call initpar()

  call from_param("fn1", fn1, "FN1")
  call from_param("fn2", fn2, "FN2")
  call from_param("fm" , fm , 10.  )
  call from_param("nx", nx, 1); call from_param("dx", dx, 1.); call from_param("ox", ox, 0.)
  call from_param("ny", ny, 1); call from_param("dy", dy, 1.); call from_param("oy", oy, 0.)
  call from_param("nz", nz, 1); call from_param("dz", dz, 1.); call from_param("oz", oz, 0.)

  allocate(refl(nx,ny,nz))

  open(unit=10, file=trim(fn1), status='old')
  open(unit=11, file=trim(fn2), status='new')

  counter = 0
  refl = 0.
  do while (.true.)
     read (10, "(A3,F13.6,F13.6,F13.6)", iostat=stat1) color, zc, xc, yc
     if (stat1<0) exit
!     write(0,*)color,zc,xc,yc
!     write(11, "(F13.6,F13.6,F13.6)"   , iostat=stat2) zc, xc, yc
     counter = counter + 1
     
     jx = 1.5+(xc-ox)/dx
     jy = 1.5+(yc-oy)/dy
     jz = 1.5+(zc-oz)/dz 
     do iz=1, nz
        refl(jx,jy,iz) = refl(jx,jy,iz)+wavelet((iz-jz)*dz, fm, 1)
     end do

!     write(0,*)color, zc, xc, yc, counter
  end do

  call to_history("n1",nx); call to_history("d1",dx); call to_history("o1",ox)
  call to_history("n2",ny); call to_history("d2",dy); call to_history("o2",oy)
  call to_history("n3",nz); call to_history("d3",dz); call to_history("o3",oz)

  call sep_write(refl)

  close(10)
  close(11)

end program
