program main
  use sep
  implicit none
  
  integer :: n1, n2, n3
  real    :: d1, d2, d3
  real    :: o1, o2, o3
  logical :: axis1, axis2, axis3, km
  real    :: fctr
  integer :: esize

  real   , dimension(:), allocatable :: rdat
  complex, dimension(:), allocatable :: cdat

  call initpar()

  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)
  call from_history("esize", esize)

  call from_param("km", km, .true.)


  if (km) then
     fctr = 0.3048*0.001
  else
     fctr = 0.3048
  end if

  if (esize==4) then
     allocate(rdat(n1*n2*n3))
     call sep_read(rdat)
     rdat = rdat * fctr
     call sep_write(rdat)

  else if (esize==8) then
     allocate(cdat(n1*n2*n3))
     call sep_read(cdat)
     cdat = cdat * fctr
     call sep_write(cdat)

  else
     write(0,*)"ERROR, esize, 4 or 8"
  end if  


end program
