program main
  use sep
  implicit none

  real, dimension(:,:,:), allocatable :: mask
  integer                             :: nx,ny,nz
  real                                :: ox,oy,oz
  real                                :: dx,dy,dz
  real                                :: xmin,xmax
  real                                :: ymin,ymax
  real                                :: zmin,zmax
  real                                :: x, y, z
  integer                             :: ix,iy,iz
  call initpar()


  call from_history("n1", nx); call from_history("d1", dx); call from_history("o1", ox)
  call from_history("n2", ny); call from_history("d2", dy); call from_history("o2", oy)
  call from_history("n3", nz); call from_history("d3", dz); call from_history("o3", oz)

! region that mask remains 1
  call from_param("xmin", xmin, 0.)
  call from_param("xmax", xmax, 0.)
  call from_param("ymin", ymin, 0.)
  call from_param("ymax", ymax, 0.)
  call from_param("zmin", zmin, 0.)
  call from_param("zmax", zmax, 0.)

  allocate(mask(nx,ny,nz))

  call sep_read(mask)

  do iz=1, nz; z = oz+(iz-1)*dz
  do iy=1, ny; y = oy+(iy-1)*dy
  do ix=1, nx; x = ox+(ix-1)*dx
     if (x>=xmin.and.x<=xmax.and.y>=ymin.and.y<=ymax.and.z>=zmin.and.z<=zmax) then
        mask(ix,iy,iz) = 1.
     else
        mask(ix,iy,iz) = 0.
     end if
  end do
  end do
  end do

  call sep_write(mask)


end program
