program main
  use sep
  implicit none


  real, dimension(:,:,:), allocatable :: refl
  integer                             :: nx, ny, nz, nlx, index_cx, index_cz, ilx, index_x, index_z
  real                                :: ox, oy, oz, dx, dy, dz, hlx, olx, x, z, dip
  real                                :: PI, cx, cz, ll

  PI = 3.14159265359

  call initpar()

  call from_param("nx", nx, 1); call from_param("dx", dx, 1.); call from_param("ox", ox, 0.)
  call from_param("ny", ny, 1); call from_param("dy", dy, 1.); call from_param("oy", oy, 0.)
  call from_param("nz", nz, 1); call from_param("dz", dz, 1.); call from_param("oz", oz, 0.)

  call from_param("cx" , cx , 0.)
  call from_param("cz" , cz , 0.)
  call from_param("ll" , ll , 1.)
  call from_param("dip", dip, 0.)

  dip = dip*PI/180. 

  allocate(refl(nx,ny,nz))


  refl = 0.

! half length in x
  hlx = nint(abs(ll*cos(dip))*0.5/dx)*dx
  olx = cx-hlx
  nlx = int(hlx/dx)*2+1

  index_cx = 1.5 + (cx-ox)/dx
  index_cz = 1.5 + (cz-oz)/dz

  do ilx=1, nlx
     x = olx + (ilx-1)*dx
     z = (x-cx)*tan(dip)
     index_z = index_cz+nint(z/dz)
     index_x = 1.5+(x-ox)/dx
     index_x = max(1,index_x); index_x = min(index_x,nx)
     index_z = max(1,index_z); index_z = min(index_z,nz)
     refl(index_x,1,index_z) = 1
  end do

  call to_history("n1", nx); call to_history("d1", dx); call to_history("o1", ox)
  call to_history("n2", ny); call to_history("d2", dy); call to_history("o2", oy)
  call to_history("n3", nz); call to_history("d3", dz); call to_history("o3", oz)

  call sep_write(refl)

end program
