#!/bin/tcsh
#PBS -N bpgom3d-invt
#PBS -l nodes=35:ppn=8
#PBS -q Q35
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -e /data/sep/tangyx/workspace/bpgom3d.born/err
#PBS -o /data/sep/tangyx/workspace/bpgom3d.born/out
#
cd $PBS_O_WORKDIR
#

set BINDIR=/data/sep/tangyx/bin
set DATDIR=/data/sep/tangyx/workspace/bpgom3d.born
set RESDIR=/data/sep/tangyx/workspace/bpgom3d.born
#set TMPDIR=/data/sep/tangyx/workspace/bpgom3d.born/junk
set TMPDIR=/tmp

cat ${PBS_NODEFILE} | sort | uniq > hostfile
set NPROCS=`wc -l hostfile | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8
mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/bwi-wet3d-mpi.x bindir=${BINDIR}/ datdir=${DATDIR}/ resdir=${RESDIR}/ tmpdir=${TMPDIR}/ suffix=-shot \
fncsou=bpgom3d-csou-born-planes.H fncrec=bpgom3d-crec-born-planes-old3.H fnbvel=vmod-old3-iter45.H \
fnbimg=bimg.H fnfobj=fobj.H fngrdo=grdo.H fngrdp=grdp.H fnsrch=srch.H \
fnimsk=bpgom3d-imsk-target.H fngmsk=bpgom3d-gmsk-target.H fnmmov=mmov.H fnfmov=fmov.H datapath=${TMPDIR}/\
masks=1 check=1 nsb=35 niter=10 alph=40 \
par_imagcube="mode=imgadj report=n memchk=n nxpad_beg=10 nxpad_end=10 nypad_beg=10 nypad_end=10 ntpx=15 ntpy=15 oper=ssfpi nvrf=4 comsou=y nws=32 image_xmin=50000 image_xmax=90000 image_ymin=65616 image_ymax=82000 nhx=21 ohx=-1640.4 dhx=164.04 " \
par_gradient="mode=tomadj report=n memchk=n nxpad_beg=10 nxpad_end=10 nypad_beg=10 nypad_end=10 ntpx=15 ntpy=15 oper=ssfpi nvrf=4 comsou=y nws=32 " \
par_residual="hcut=0 dsotyp=1 objeps=7.e-07 objtyp=offdso dsorms=y imgmsk=y" \
par_gradprcs="grdmsk=y gscale=y smtgrd=y smttyp=spline xk_min=42000 xk_max=95000 nxk=45 yk_min=61000 yk_max=87500 nyk=23 zk_min=15000 zk_max=35000 nzk=34 " > log
