import os, sys
from optparse import OptionParser

usage = 'usage: %prog [options] arg1 arg2'

parser = OptionParser(usage=usage)

parser.add_option('--filename', dest='filename', type='string', default='FILE.H', help='file to be splitted')
parser.add_option('--suffix'  , dest='suffix'  , type='string', default='-shot' , help='file extension')
parser.add_option('--method'  , dest='method'  , type='string', default='split' , help='[split]/copy')
parser.add_option('--axis'    , dest='axis'    , type='string', default='4'     , help='[4]')
parser.add_option('--nsx_tot' , dest='nsx_tot' , type='string', default='1'     , help='Total number of shots')
parser.add_option('--jsx_win' , dest='jsx_win' , type='string', default='1'     , help='Number of shots in a windowed shot in x')

(options, args) = parser.parse_args()

FILENAME = options.filename
FILENAME_SPLIT = options.filename + options.suffix + '%d'
AXIS = options.axis

NSX_TOT = int(options.nsx_tot)
JSX_WIN = int(options.jsx_win)
JSX_RES = NSX_TOT % JSX_WIN

if JSX_RES == 0:
	NSX_WIN = NSX_TOT/JSX_WIN
else:
	NSX_WIN = (NSX_TOT-JSX_RES)/JSX_WIN + 1

print 'NSX_TOT = ', NSX_TOT
print 'JSX_WIN = ', JSX_WIN
print 'JSX_RES = ', JSX_RES
print 'NSX_WIN = ', NSX_WIN

SHOT_INDEX_BEG = 1
SHOT_INDEX_END = NSX_WIN + 1

#########
# loop over shots
#########
for ishot in range(SHOT_INDEX_BEG, SHOT_INDEX_END):
	###############
	if options.method=='split':
		if JSX_RES==0:
			cmd = 'Window3d < ' + FILENAME + ' n%s'%AXIS + '=%d'%JSX_WIN + ' f%s'%AXIS + '=%d'%((ishot-1)*JSX_WIN) + ' squeeze=n >' + FILENAME_SPLIT%ishot
		else:
			if ishot<SHOT_INDEX_END-1:
				cmd = 'Window3d < ' + FILENAME + ' n%s'%AXIS + '=%d'%JSX_WIN + ' f%s'%AXIS + '=%d'%((ishot-1)*JSX_WIN) + ' squeeze=n >' + FILENAME_SPLIT%ishot
			else:
				cmd = 'Window3d < ' + FILENAME + ' n%s'%AXIS + '=%d'%JSX_RES + ' f%s'%AXIS + '=%d'%((NSX_WIN-1)*JSX_WIN) + ' squeeze=n >' + FILENAME_SPLIT%NSX_WIN
	else:
		cmd = 'Cp ' + FILENAME + ' ' + FILENAME_SPLIT%ishot
	print cmd
	os.system(cmd)
