#!/bin/tcsh
#PBS -N HESINV
#PBS -l nodes=17:ppn=2
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -e /data/sep/tangyx/workspace/bpgom3d.lsmi/err
#PBS -o /data/sep/tangyx/workspace/bpgom3d.lsmi/out
#
cd $PBS_O_WORKDIR
#
set BINDIR=/data/sep/tangyx/bin
set DATDIR=/data/sep/tangyx/workspace/bpgom3d.lsmi
set RESDIR=/data/sep/tangyx/workspace/bpgom3d.lsmi
#set TMPDIR=/data/sep/tangyx/workspace/bpgom3d.born/junk
set TMPDIR=/tmp

cat ${PBS_NODEFILE} | sort | uniq > hostfile
set NPROCS=`wc -l hostfile | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=2

mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/hesinv-mpi.x hess=${DATDIR}/lsm3d-hess-offd-target-half.H refl=${DATDIR}/inv-dip.H \
imag=${RESDIR}/lsm3d-imag-flat.H mask=${RESDIR}/lsm3d-mask-flat.H dipr=${RESDIR}/lsm3d-refl-pick.H hwgt=${RESDIR}/lsm3d-hess-diag-smooth.H \
mmov=${RESDIR}/mmov-dip.H resd=${RESDIR}/resd-dip.H resm=${RESDIR}/resm-dip.H niter=100 smooth=y \
rectx_dip=6 recty_dip=6 rectz_dip=6 nsmt_dip=6 dip_min=-50 dip_max=50 ndip=101 dipeps=0.1 scheme=UW2x3 na=4 estdip=n const_dipx=-30 const_dipy=30 >log

#mpirun -machinefile ./hostfile -np ${NPROCS} ${BINDIR}/hescon-mpi2.x hess=${DATDIR}/lsm3d-hess-small-half.H refl=${DATDIR}/lsm3d-refl-spike-small.H \
#imag=${RESDIR}/test.H parallel_io=y >log

#mpirun ${BINDIR}/hesinv-mpi-c.x hess=${DATDIR}/lsm3d-hess-small-half.H refl=${DATDIR}/lsm3d-refl-spike-small.H \
#imag=${RESDIR}/test.H >log
