import os, sys
from optparse import OptionParser

usage = 'usage: %prog [options] arg1 arg2'

parser = OptionParser(usage=usage)

parser.add_option('--history', dest='history', type='string', default=' ', help='History file')
parser.add_option('--command', dest='command', type='string', default=' ', help='Command to be run')
parser.add_option('--index_beg', dest='index_beg', type='int', default=1, help='Beginning index')
parser.add_option('--index_end', dest='index_end', type='int', default=1, help='Ending index')

(options, args) = parser.parse_args()

BINDEX = options.index_beg 
EINDEX = options.index_end + 1

root, ext = os.path.splitext(options.command)

TARGET = root + '%d' + ext

cmd = 'set next: in="'
for index in range(BINDEX, EINDEX):
	cmd = cmd + (TARGET % index) + '@'
	if index!=options.index_end:
		cmd = cmd + ';'
cmd = cmd + '"\n'
f = open(options.history, "a")
f.write(cmd)
f.close()
