#!/usr/bin/python
import sys,re,os,string
import commands
import array
import os

import math
from sepbase import *

def self_doc():
  print 
  print 
  print 
  print 
  print 

#see if two rectangles overlap or not
def is_rect_overlap(xmin1,xmax1,ymin1,ymax1,xmin2,xmax2,ymin2,ymax2):
  bOverLapX = (xmin1 >= xmin2 and xmin1 < xmax2) or (xmin2 >= xmin1 and xmin2 < xmax1)  
  bOverLapY = (ymin1 >= ymin2 and ymin1 < ymax2) or (ymin2 >= ymin1 and ymin2 < ymax1)  
  return bOverLapX,bOverLapY

## This program will try to filter shotsInfo from a full-list of shotsInfo based on the region of interest
## The output is also a shotsInfo type file
# Usage:    *.py fname.shotsInfo output=fout.shotsInfo roi_x=xmin,xmax roi_y=ymin,ymax [roi_z=zmin,zmax] 

eq_args,args=parse_args(sys.argv[1:])
his_eachshot={}
#get_sep_grid_params(fname,his_grid,'g')
#set global limits based on the size of velocity model
vxmin=2250;vxmax=36450;vymin=-18180;vymax=15960
print eq_args,"\n"

fno_shotsInfo = ""; fni_shotsInfo = ""
fni_shotsInfo = args[0]
if eq_args.has_key("output"):
  fno_shotsInfo=eq_args["output"]
else:
  err("specify output!!!")

fp_i = open(fni_shotsInfo,"r"); fp_o = open(fno_shotsInfo,"w")
fp_rest = None
if 'rest' in eq_args:
  fp_rest = open(eq_args['rest'],"w")

#Read in the region of interest
roi_xmin=roi_xmax=0;roi_ymin=0;roi_ymax=0;roi_zmin=0;roi_zmax=0
if eq_args.has_key("roi_x"):
  str_xs = eq_args["roi_x"].split(",")
  roi_xmin = float(str_xs[0]); roi_xmax = float(str_xs[1])
else:
  err("no roi_x= !!")
if eq_args.has_key("roi_y"):
  str_ys = eq_args["roi_y"].split(",")
  roi_ymin = float(str_ys[0]); roi_ymax = float(str_ys[1])
else:
  err("no roi_y= !!")
if eq_args.has_key("roi_z"):
  str_zs = (eq_args["roi_z"]).split(",")
  roi_zmin = float(str_zs[0]); roi_zmax = float(str_zs[1])
else:
  print "no roi_z"
print "roi dimensions", roi_xmin,roi_xmax,roi_ymin,roi_ymax

## Parse the input shotsInfo file, and select useful shots based on the region of interest information, also output total migration domain required to accommodate the final dataset
lines_output = []
lines_output_rest = []

bin_Y = "/net/server/yang/bin"
iline=0; bMarine = True; nfiles = 0; ifcnt = 0
line = ""; line2=""; strlist_line1 = [];
b_enterY = False
while 1:
  line = fp_i.readline();
  if not line: #ifeof
    break
  else:
    line = line.rstrip('\n')
    if line!="": ## parse each line
      iline = iline+1
      if iline==1: ## first line, important info needs to be extracted, first line exp: 420 bMarineGeom=y singleSrcFileForAllShots=y /data/sep/zyang03/data/waz/csou-waz3d.H 
        strlist_line1 = line.split(" ")
      if iline==2: ## second line, exp: fname_data xmin xmax ymin ymax 
        line2 = line
        str_lists = (line).split(" ")
        if (str_lists[0] != "fname_data"):
          err("2nd line begining is 'fname_data'")
      if iline>2: # the rest, start with the shots filename
        str_lists = (line).split(" ")
        fn_shot = str_lists[0] # read the aperture info from the shotsInfo file directly
        xmin,xmax,ymin,ymax = map(float,str_lists[1:])
        print "icnt=%d, Aperture xmin/xmax/ymin/ymax = %f %f %f %f"%(ifcnt,xmin,xmax,ymin,ymax)
        #if this shot is relavant
        x_overlap,y_overlap = is_rect_overlap(xmin,xmax,ymin,ymax,roi_xmin,roi_xmax,roi_ymin,roi_ymax)
        if (x_overlap and y_overlap):
          b_enterY = True
          ifcnt = ifcnt+1; lines_output.append(line)
        else:
          if fp_rest:
            lines_output_rest.append(line)
            print lines_output_rest[-1]
        #if (not y_overlap and b_enterY):
        #  break
#Put the first two lines of the output file in place
cmd1 = "%d %s\n"%(ifcnt," ".join(strlist_line1[1:])); cmd2 = line2
fp_o.write(cmd1); fp_o.write(line2+"\n")
fp_o.write("\n".join(lines_output))
fp_o.write("\n")
fp_o.close(); fp_i.close()
if fp_rest:
  fp_rest.write(cmd1); fp_rest.write(line2+"\n")
  fp_rest.write("\n".join(lines_output_rest))
  fp_rest.write("\n")
  fp_rest.close()

