#!/usr/bin/python
import commands,os,sys
import pbs_util
import sepbase

## Make the given node in the nodelist busy so that they won't be scheduled with real jobs. An workaround to deal with the malfunctioned nodes.

# Usage1:    *.py pbs_template=pbs_script_tmpl.sh prefix=occupy queue=q35 nsec=[86400] nodes=rcf085,... path_out=pathout

def Run(argv):
  print "Occpuy.py params:", argv
  eq_args_from_cmdline,args = sepbase.parse_args(argv)
  dict_args = sepbase.RetrieveAllEqArgs(eq_args_from_cmdline)
  queue = dict_args['queue']
  nodes = dict_args['nodes'].split(',')
  dict_args['queues'] = queue
  dict_args['queues_cap'] = '100'
  dict_args['total_jobs_cap'] = '200'
  dict_args['prefix']='occupy'
  param_reader = pbs_util.JobParamReader(dict_args)
  prefix = param_reader.prefix
  pbs_script_creator = pbs_util.PbsScriptCreator(param_reader)
  if param_reader.queues[0] == 'default':
    print 'WARN: Consider putting sep queue ahead of the default queue.'
  nsec = dict_args.get('nsec','86400')  # default is one day
  nsec = int(nsec)
  for node in nodes:
    scripts = []
    cmd = 'sleep %d\n' % nsec
    scripts.append(cmd)
    pbs_script_creator.CreateScriptForNewJob(node)
    fn_script = pbs_script_creator.AppendScriptsContent(scripts)
    cmd1 = "qsub -q %s %s -l nodes=%s" % (queue, fn_script, node)
    sepbase.RunShellCmd(cmd1,True)
  return


if __name__ == '__main__':
  Run(sys.argv)

